# MathTeXEngine

This is a package aimed at providing a pure Julia engine for LaTeX math mode. It is composed of two main parts: a LaTeX parser and a LaTeX engine, both only for LaTeX math mode.

# Main features

- Parsing of (possibly nested) LaTeX expression and creation of a layout for them.
- Equivalence between traditional LaTeX commands and their unicode input equivalent.
- Pure julia.

# Fonts

The characters in a math expression come from a variety of fonts depending on their role (most notably italic for variable, regular for functions, math for the symbols).
A set of such font forms a `FontFamily`, and several are predefined here (NewComputerModer, TeXGyreHeros, TeXGyrePagella, and LucioleMath)
and can be access by `FontFamily(name)`.

A font family is defined by a dictionary of the paths of the font files:
```julia
julia> FontFamily("NewComputerModern")
FontFamily with 13.0° slant angle and 0.0375 line thickness
  bold        =>  NewComputerModern\NewCM10-Bold.otf
  bolditalic  =>  NewComputerModern\NewCM10-BoldItalic.otf
  italic      =>  NewComputerModern\NewCM10-Italic.otf
  math        =>  NewComputerModern\NewCMMath-Regular.otf
  regular     =>  NewComputerModern\NewCMMath-Regular.otf
```

Currently, there are two ways to get the font information to Makie.

First, change the global default font family using `set_texfont_family!`,
which take either a font family as an argument or a list of (`Symbol`, path to the font file) pairs.
```julia
# Change to a different font familiy entirely
julia> set_texfont_family!(FontFamily("LucioleMath"))
FontFamily with 13.0° slant angle and 0.0375 line thickness
  bold        =>  Luciole-Math\Luciole-Bold.ttf
  bolditalic  =>  Luciole-Math\Luciole-Bold-Italic.ttf
  italic      =>  Luciole-Math\Luciole-Regular-Italic.ttf
  math        =>  Luciole-Math\Luciole-Math.otf
  regular     =>  Luciole-Math\Luciole-Regular.ttf

# Change just the regular and bold fonts, keep the default for the rest
julia> set_texfont_family!(
   regular = raw"C:\Users\Kolaru\.julia\dev\MathTeXEngine\experimental\utopia\Utopia-Regular.ttf",
   bold = raw"C:\Users\Kolaru\.julia\dev\MathTeXEngine\experimental\utopia\Utopia-Bold.ttf")
FontFamily with 13.0° slant angle and 0.0375 line thickness
  bold        =>  C:\Users\Kolaru\.julia\dev\MathTeXEngine\experimental\utopia\Utopia-Bold.ttf
  bolditalic  =>  NewComputerModern\NewCM10-BoldItalic.otf
  italic      =>  NewComputerModern\NewCM10-Italic.otf
  math        =>  NewComputerModern\NewCMMath-Regular.otf
  regular     =>  C:\Users\Kolaru\.julia\dev\MathTeXEngine\experimental\utopia\Utopia-Regular.ttf

# Switch back to the default
julia> set_texfont_family!()
FontFamily with 13.0° slant angle and 0.0375 line thickness
  bold        =>  NewComputerModern\NewCM10-Bold.otf
  bolditalic  =>  NewComputerModern\NewCM10-BoldItalic.otf
  italic      =>  NewComputerModern\NewCM10-Italic.otf
  math        =>  NewComputerModern\NewCMMath-Regular.otf
  regular     =>  NewComputerModern\NewCMMath-Regular.otf
```

Alternatively, the special command `\fontfamily{FontName}` can be used in the LaTeX string itself
to choose the font, for example `L"\fontfamily{TeXGyreHeros}x^2 + y^2 = 1"`.
The font name must be in the global dictionary `MathTeXEngin.default_font_families`.
If needed, it can be extended at runtime.

# Engine

The main use of the package is through `generate_tex_elements` taking a LaTeX string as input and return a list of tuples `(TeXElement, position, scale)` where `TeXElement` is one of the following:

- `TeXChar(char, font)` a unicode character to be displayed in a specific font.
- `VLine(height, thickness)` a vertical line.
- `HLine(width, thickness)` an horizontal line.

This contains enough information to then draw everything with any plotting package that can draw arbitrary glyph in arbitrary font. The position is the origin of the character according to `FreeType`.

Positions and scales are given for a font size of `1`. For bigger font size they simply need to be multiplied by the font size.

The engine should support every construction the parser does (see below).

Currently the only font set supported is Computer Modern.

## Engine examples

### Basic examples

```julia
julia> using MathTeXEngine

julia> generate_tex_elements(L"\beta_2")
2-element Vector{Any}:
 (TeXChar 'β' [U+00AF in cmmi10 - Regular], [0.0, 0.0], 1.0)
 (TeXChar '2' [U+0032 in cmr10 - Regular], [0.56494140625, -0.20000000298023224], 0.6)
```

The `L"..."` macro is reexported from LaTeXStrings.jl and used to convey the information that we want the given string to be interpreted as LaTeX. Note that since we are using Computer Modern, which is a pre-unicode font family, the characters are distributed across a bunch of different fonts.

Also note that Unicode character can be used directly and are equivalent to their command.

```julia
julia> generate_tex_elements(L"β_2")
2-element Vector{Any}:
 (TeXChar 'β' [U+00AF in cmmi10 - Regular], [0.0, 0.0], 1.0)
 (TeXChar '2' [U+0032 in cmr10 - Regular], [0.56494140625, -0.20000000298023224], 0.6)
```

Using the inline math mode with `$...$` is supported. However, currently, line breaks or line wraps are not.

```julia
julia> generate_tex_elements(L"b $β_2$")
4-element Vector{Any}:
 (TeXChar 'b' [U+0062 in cmr10 - Regular], [0.0, 0.0], 1.0)
 (TeXChar ' ' [U+0020 in cmr10 - Regular], [0.55517578125, 0.0], 1.0)
 (TeXChar 'β' [U+00AF in cmmi10 - Regular], [0.88818359375, 0.0], 1.0)
 (TeXChar '2' [U+0032 in cmr10 - Regular], [1.453125, -0.20000000298023224], 0.6)
```

### VLine and Hline

Some LaTeX constructs, mainly square roots and fractions generate additional lines that are not representing a character. The `HLine` or `VLine` object contain all information needed to draw the line correctly.

```julia
julia> elements = generate_tex_elements(L"\frac{1}{2}")
3-element Vector{Any}:
 (HLine{Float64}(0.614990234375, 0.009765625), [0.0, 0.210693359375], 1.0)
 (TeXChar '1' [U+0031 in cmr10 - Regular], [0.1405029296875, 0.42626953125], 1.0)
 (TeXChar '2' [U+0032 in cmr10 - Regular], [0.1077880859375, -0.6708984375], 1.0)

julia> hline = elements[1][1]
HLine{Float64}(0.614990234375, 0.009765625)

julia> hline.width
0.614990234375

julia> hline.thickness
0.009765625
```

### Nested expressions

A flat list is always returned even if the LaTeX expression is deeply nested.

```julia
julia> generate_tex_elements(L"A_{B_{C_D}}")
4-element Vector{Any}:
 (TeXChar 'A' [U+0041 in cmmi10 - Regular], [0.0, 0.0], 1.0)
 (TeXChar 'B' [U+0042 in cmmi10 - Regular], [0.75, -0.20000000298023224], 0.6)
 (TeXChar 'C' [U+0043 in cmmi10 - Regular], [1.2046875, -0.3200000047683716], 0.36)
 (TeXChar 'D' [U+0044 in cmmi10 - Regular], [1.4616796874999998, -0.3920000058412552], 0.216)
```


# Parser

Parsing is done through the exported function `texparse` into nested `TeXExpr` objects forming a tree. The parser does not perform any operation to layout the elements, it only transforms them into a syntax tree.

The readme file in the `src/parser` folder contains more details about the inner working of the parser.

## Supported constructions

The table below contains the list of all supported LaTeX construction and their representation when parsed.

| Description | LaTeX example | Expression head | Fields |
|--|--|--|--|
| Accent | `\vec{v}` | `:accent` | `symbol, core` |
| Char | `x` | `:char` |
| Digit | `3` | `:digit` |
| Delimiter | `\left( \right)` | `:delimited` | `left_delimiter, content, right_delimiter` |
| Fraction | `\frac{}{}` | `:frac` | `numerator, denumerator` |
| Function | `\sin` | `:function` | `name` |
| Generic symbol | `ω` | `:symbol` | `unicode_char` |
| Group | `{ }` | `:group` | `elements...` |
| Inline math | `$ $` | `:inline_math` | `content` |
| Integral | `\int_a^b` | `:integral` | `symbol, low_bound, high_bound` |
| Math fonts | `\mathrm{}` | `:font` | `font_modifier, expr` |
| Punctuation | `!` | `:punctuation` |
| Simple delimiter | `(` | `:delimiter` |
| Square root | `\sqrt{2}` | `:sqrt` | `content` |
| Space | `\quad` | `:space` | `width` |
| Spaced symbol | `+` | `:spaced` | `symbol` |
| Subscript and superscript | `x_0^2` | `:decorated` | `core, subscript, superscript` |
| Symbol with script under and/or over it | `\sum_i^k` | `:underover` | `symbol, under, over` |

## Parser examples

### Basic examples

```julia
julia> texparse(raw"\beta_2")
TeXExpr :expr        
└─ TeXExpr :decorated
   ├─ TeXExpr :symbol
   │  └─ 'β'
   ├─ TeXExpr :digit
   │  └─ '2'
   └─ nothing
```

The Unicode input are supported at the parser level.

```julia
julia> expr = texparse(raw"β_2")
TeXExpr :expr
└─ TeXExpr :decorated
   ├─ TeXExpr :symbol
   │  └─ 'β'
   ├─ TeXExpr :digit
   │  └─ '2'
   └─ nothing
```

`TeXExpr` have the same `head` - `args` structure as the built-in `Expr`.

```julia
julia> expr.args[1].head
:decorated

julia> expr.args[1].args
3-element Vector{Any}:
 TeXExpr :symbol
└─ 'β'

 TeXExpr :digit
└─ '2'

 nothing
```

# Acknowledgement

The font inspector site [FontDrop!](https://fontdrop.info) has been invaluable for this package.

# Reference test

To run the reference tests, simply run `compare.jl`. This will download the reference files corresponding to the latest release.

To generate new reference images, run `generate.jl`. This will generate `reference_images.tar`.

# Parse developer documentation

This is a quick introduction on how the parser is working.
It gives a short introduction to each file in the order they are loaded.

## texexpr.jl

This file contains the definition of the `TeXExpr` struct.
It is used as the representation for *all* the outputs of the parser.
It works similarly as Julia built-in expr, having two fields:
- `head::Symbol` : the identifier of the kind of `TeXExpr` used.
    See the main documentation for a list of valid names.
- `args::Vector{Any}` : a list of all the data associated with the expression.
    For example for a `TeXExpr` with head `digit`, `args` is a list containing
    a single element, the digit represented by the expression.
    Arguments can be either `TeXExpr` themselves, or other Julia types,
    typically `Char` or `String`.

## commands_data.jl

This file simply lists family of command for easier registration in the next
step.
It is based on the commands defined for `mathtext` the latex engine of
`matplotlib`.

## commands_registration.jl

In this file we map a single symbol or a string representing a latex
command to its `TeXExpr` representation through the `canonical_expr` function.
For example, the string `"\alpha"` is mapped to `TeXExpr(:symbol, 'α')`.

Here we introduce the concept of a canonical representation.
This simply has to do with the fact that sometime different latex inputs can
lead to the same expression, and we represent them in a unique and
consistent way.
For example, both the strings `"\alpha"` and `"α"` are mapped to the
expression `TeXExpr(:symbol, 'α')`.

Note that the canonical expression may not be the final expression that
the parser outputs.
Sometimes additional informations need to be parsed to complete the command.
In such case, the canonical expression is a `TeXExpr` that is further
modified when the needed information are parsed.
There are currently two main use cases:
- LaTeX macros with arguments, like `\frac`, that are mapped to
    `TeXExpr(:argument_gatherer, [head, number_of_args])` that are converted
    to `TeXExpr(head, args)` once the arguments are parsed and gathered.
- Constructs with optional modifiers, like `\int` that can optionally their
    bounds specified.
    In this case the optional arguments of the expression are initially
    filled with `nothing` and are later replaced with their actual value if
    they are found while parsing.

This strategy allows the parser to only move forward without explicit
lookahead.

## parser.jl

This is where the magic happens, in the `texparse` function.
For the most part it contains the definition of the parser using `Automa.jl`.
A lot need to be learn from `Automa.jl` documentation before diving in here.

In addition to `Automa.jl` native capabilities, to be able to parse a rich
language like latex, we need to manage a stack
that contain both the current state of parsing and the already parsed data.
The strategy is relatively simple:
1. We put a `TeXExpr(:expr, [])` as initial state of the stack.
2. We parse LaTeX strings character by character (`Automa.jl` do it byte by
    byte, some care is needed to do it unicode char by unicode char).
3. When we encouter a new construct, we put its canonical representation on
    top of the stack (e.g. `{` start a new `TeXExpr(:group)`).
4. When we encouter a char that can end the current construct, we finalize it.
    That is we pop it from the stack and apply some final transformation  to it
    if needed (e.g. removing the useless `TeXExpr(:group)` layer for a
    group of a single element).
    Then we add it to the argument list of the first construct below.

Note that some construct, like digits, are composed of only a single char so for them
steps 3 and 4 are merged and they are simply added to the current construct.

Most of the complexity in the file comes from the fact that there are
many special rules for beginning or ending a construct.
Think for example of superscript.
Starting from the string `"10^"`, the superscript construct can be terminated
by either
- A single char e.g. `"10^2"`.
- A command e.g. `"10^\beta"`.
- A group e.g. `"10^{2 + 3}`.

Regardless, at the end, when the parsing is successful, the stack
collapses to a single element, `TeXExpr(:expr)` which arguments contain
a nested representation of the full LaTeX string.

You can watch the rise and fall of the stack by passing `showdebug=true` to
`texparse`.
It is currently not as fun as to watch an old empire rise and fall,
but beware, it is nearly as verbose.

using CairoMakie
using MathTeXEngine

offset = 8400
ncols = 30
nrows = 15

glyph_ids = [offset + j + (i -1)*ncols for i in 1:nrows, j in 1:ncols]
font = "assets/fonts/NewComputerModern/NewCMMath-Regular.otf"
fig = Figure(; size = (1800, 1000))

for ci in CartesianIndices(glyph_ids)
    gid = glyph_ids[ci]
    try
        Label(fig[ci[1], ci[2]], "$(Char(gid))" ; font)
    catch
        Label(fig[ci[1], ci[2]], " " ; font)
    end
end

fig

module MathTeXEngine
# Adapted from matplotlib mathtext engine
# https://github.com/matplotlib/matplotlib/blob/master/lib/matplotlib/_mathtext.py

using AbstractTrees
using Automa
using FreeTypeAbstraction
using LaTeXStrings
using UnicodeFun

using DataStructures: Stack
using GeometryBasics: Point2f, Rect2f
using REPL.REPLCompletions: latex_symbols
using RelocatableFolders

import FreeTypeAbstraction:
    ascender, boundingbox, descender, get_extent, glyph_index,
    hadvance, inkheight, inkwidth,
    height_insensitive_boundingbox, leftinkbound, rightinkbound,
    topinkbound, bottominkbound

export TeXToken, tokenize
export TeXExpr, texparse, TeXParseError, manual_texexpr
export TeXElement, TeXChar, VLine, HLine, generate_tex_elements
export texfont, FontFamily, set_texfont_family!, get_texfont_family
export glyph_index

# Reexport from LaTeXStrings
export @L_str

include("parser/tokenizer.jl")
include("parser/texexpr.jl")
include("parser/commands_data.jl")
include("parser/commands_registration.jl")
include("parser/parser.jl")

include("engine/computer_modern_data.jl")
include("engine/new_computer_modern_data.jl")
include("engine/fonts.jl")
include("engine/layout_context.jl")
include("engine/texelements.jl")
include("engine/layout.jl")

end # module

_latex_to_new_computer_modern = Dict(
    raw"\int" => 5930,
    raw"\sum" => 5941,

    raw"\partial" => 3377,
    raw"\varepsilon" => 3356,
    raw"\vartheta" => 3379,
    raw"\varkappa" => 3380,
    raw"\varphi" => 3373,
    raw"\varrho" => 3382,
    raw"\varpi" => 3383,

    raw"\epsilon" => 3378,
    raw"\theta" => 3359,
    raw"\kappa" => 3361,
    raw"\phi" => 3381,
    raw"\rho" => 3368,
    raw"\pi" => 3367
)


_symbol_to_new_computer_modern = Dict{Char, Tuple{String, Int}}()
cmmath_fontpath = joinpath("NewComputerModern", "NewCMMath-Regular.otf")

for (symbol,  glyph_id) in _latex_to_new_computer_modern
    if haskey(latex_symbols, symbol)
        symbol = latex_symbols[symbol][1]
    else
        symbol = symbol[1]
    end
    
    _symbol_to_new_computer_modern[symbol] = (cmmath_fontpath, glyph_id)
end

# Standard lowercase greek symbols : thin and italic
for i in 0:24
    small = 'α' + i

    if !haskey(_symbol_to_new_computer_modern, small)
        _symbol_to_new_computer_modern[small] = (cmmath_fontpath, 3352 + i)
    end
end

# Special case : get hbar from the italic font
_symbol_to_new_computer_modern['ħ'] = (
    joinpath("NewComputerModern", "NewCM10-Italic.otf"),
    231
)

struct TeXParseError <: Exception
    msg::String
    stack::Stack
    position::Int
    tex
end

function Base.showerror(io::IO, e::TeXParseError)
    println(io, "TeXParseError: ",  e.msg)
    show_state(io, e.stack, e.position, e.tex)
    show_tokenization(io, e.tex)
end

function show_tokenization(io, tex)
    println(io, "TeX expression tokenized as")
    println(io, "index : token_type [length]")
    for (i, len, token) in tokenize(TeXToken, tex)
        println(io, "$i : $token [$len]")
    end
    println(io)
end

show_tokenization(tex) = show_tokenization(stdout, tex)

function show_state(io::IO, stack, position, tex)
    # Everything is shifted by one
    if position > lastindex(tex)
        println(io, "after the end of the latex string")
        println(io, tex)
    else
        # Compute the index of the char from the byte index
        position_to_id = zeros(Int, lastindex(tex))
        id = 0
        for p in 1:lastindex(tex)
            if isvalid(tex, p)
                id += 1
            end
            position_to_id[p] = id
        end
        p = position_to_id[position]
        println(io, "at position ", position, " (string index ", p, ")")
        println(io, tex)
        println(io, " " ^ (p - 1), "^")
    end

    println(io, "Stack")
    show_stack(io, stack)
    println(io)
end

show_state(stack, position, tex) = show_state(stdout, stack, position, tex)

function show_stack(io, stack)
    for (k, level) in enumerate(stack)
        K = length(stack) - k + 1
        print(io, "[$K] ", level)
    end
end

show_stack(stack) = show_stack(stdout, stack)

function push_down!(stack, math_mode = false)
    top = pop!(stack)
    if head(top) == :group
        # Replace empty groups by 0 spaces
        if isempty(top.args)
            top = TeXExpr(:space, 0.0)
        # Unroll group with single elements
        elseif length(top.args) == 1
            top = only(top.args)
        end
    end

    if unspace_binary_operators_heuristic_enabled[] && math_mode && head(top) == :spaced
        if !_has_plausible_binary_left_argument(first(stack))
            top = only(top.args)
        end
    end

    push!(first(stack), top)

    if head(first(stack)) in [:subscript, :superscript]
        decoration = pop!(stack)
        decorated = pop!(first(stack))
        decorated.args[subsuperindex(head(decoration))] = first(decoration.args)
        push!(first(stack).args, decorated)
    end

    conclude_command!!(stack, math_mode)
end

function conclude_command!!(stack, math_mode = false)
    com = first(stack)
    head(com) != :command && return false
    nargs = length(com.args) - 1

    if required_args(first(com.args)) == nargs
        pop!(stack)
        push!(stack, command_expr(com.args[1], com.args[2:end]))
        push_down!(stack, math_mode)
    end
end

function subsuperindex(dec)
    if dec == :subscript
        return 2
    elseif dec == :superscript
        return 3
    end
    error()
end

function delimiter(com_str, str)
    str = str[length(com_str)+1:end]
    if length(str) == 1
        char = only(str)
        if char == '<'
            char = '⟨'
        elseif char == '>'
            char = '⟩'
        end
        return TeXExpr(:delimiter, char)
    else
        return only(texparse(str).args)
    end
end

"""
    texparse(tex::String ; showdebug=false)

Parse a string representing a single LaTeX expression into nested TeXExpr.

See the documentation for the possible combinations of expression head and
arguments.

Setting `showdebug` to `true` show a very verbose break down of the parsing.
"""
function texparse(tex ; root = TeXExpr(:lines), showdebug = false)
    if showdebug
        show_tokenization(tex)
    end

    contains_math = occursin(raw"$", tex)

    stack = Stack{Any}()
    inside_math = false
    push!(stack, root)
    push!(stack, TeXExpr(:line))

    for (pos, len, token) in tokenize(TeXToken, tex)
        if showdebug
            show_state(stack, pos, tex)
        end
        # Skip the invalid part of unicode characters
        !isvalid(tex, pos) && continue

        try
            if token == dollar
                if head(first(stack)) == :inline_math
                    inside_math = false
                    push_down!(stack, true)
                else
                    inside_math = true
                    push!(stack, TeXExpr(:inline_math))
                end
            elseif token == newline
                if length(stack) > 2
                    throw(TeXParseError("unexpected new line", stack, length(tex), tex))
                end

                push_down!(stack, inside_math)
                push!(stack, TeXExpr(:line))
            elseif token == lcurly
                push!(stack, TeXExpr(:group))
            elseif token == rcurly
                if head(first(stack)) != :group
                    throw(TeXParseError("missing closing '}'", stack, pos, tex))
                end
                push_down!(stack, inside_math)
            elseif token == left
                push!(stack, TeXExpr(:delimited, delimiter(raw"\left", tex[pos:pos+len-1])))
            elseif token == right
                delimited = pop!(stack)
                if head(delimited) != :delimited
                    throw(TeXParseError("missing closing delimiter", stack, pos, tex))
                end
                left_delim, content... = delimited.args
                right_delim = delimiter(raw"\right", tex[pos:pos+len-1])
                if length(content) == 1
                    content = only(content)
                else
                    content = TeXExpr(:group, content)
                end

                push!(first(stack), TeXExpr(:delimited, [left_delim, content, right_delim]))
            elseif token == command
                com_str = tex[pos:pos+len-1]
                push!(stack, TeXExpr(:command, [com_str]))
                conclude_command!!(stack, inside_math)
            elseif token == underscore || token == caret || token == primes
                dec = (token == underscore) ? :subscript : :superscript

                if isempty(first(stack).args)
                    core = TeXExpr(:space, 0.0)
                else
                    core = pop!(first(stack))
                end

                if !(head(core) in [:decorated, :underover, :integral])
                    core = TeXExpr(:decorated, [core, nothing, nothing])
                end

                if !isnothing(core.args[subsuperindex(dec)])
                    throw(TeXParseError("multiple $token given", stack, pos, tex))
                end

                push!(first(stack), core)

                if token == primes
                    core.args[subsuperindex(dec)] = TeXExpr(:primes, len)
                else
                    push!(stack, TeXExpr(dec))
                end
            elseif token == char
                c = tex[pos]

                # hyphen replaced by minus sign if expression does not contain
                # inline math at all, or the hyphen is inside inline math
                if c == '-'
                    if !contains_math || inside_math
                        expr = TeXExpr(:spaced, TeXExpr(:symbol, '−'))
                    else
                        expr = TeXExpr(:char, '-')
                    end
                else
                    expr = canonical_expr(c)
                end
                push!(stack, expr)
                push_down!(stack, inside_math)
            end
        catch err
            throw(TeXParseError("unexpected error", stack, pos, tex))
        end
    end

    if head(first(stack)) == :line
        push_down!(stack, inside_math)
    end

    if length(stack) > 1
        throw(TeXParseError("unexpected end of input", stack, length(tex), tex))
    end

    lines = only(stack)
    if length(lines.args) == 1
        return only(lines.args)
    else
        return lines
    end
end

function _has_plausible_binary_left_argument(expr)
    if head(expr) in
       (:punctuation, :space, :function, :integral, :underover, :superscript, :subscript)
        return false
    elseif head(expr) == :delimiter
        return !(length(expr.args) == 1 && expr.args[1] in ('(', '[', '⟨', '{'))
    elseif head(expr) in (:line, :inline_math, :group, :delimited)
        isempty(expr.args) && return false
        return _has_plausible_binary_left_argument(last(expr.args))
    end

    return true
end

const FONTS = RelocatableFolders.@path joinpath(@__DIR__, "..", "..", "assets", "fonts")
# joinpath() (and its ispath() check) becomes expensive when repeated for every
# ascender, descender and TeXChar
const FONTNAME_TO_FULLPATH = Dict{String, String}()

function full_fontpath(fontname::String)
    isfile(fontname) && return fontname
    return get!(FONTNAME_TO_FULLPATH, fontname) do
        return joinpath(FONTS, fontname)
    end
end

function full_fontpath(fontname::AbstractString)
    isfile(fontname) && return fontname
    return joinpath(FONTS, fontname)
end

const _cached_fonts = Dict{String, FTFont}()

"""
    load_font(str)

Load a font. `str` must be either the full path to the font file, or a font in
the package font folder.

A font at a given location is cached for further use.
"""
function load_font(str)
    path = full_fontpath(str)
    get!(_cached_fonts, path) do
        FTFont(path)
    end
end

# Loading the font directly here lead to FreeTypeAbstraction to fail with error
# code 35, because handles to fonts are C pointer that cannot be fully
# serialized at compile time


const _default_font_mapping = Dict(
    :text => :regular,
    :delimiter => :regular,
    :digit => :regular,
    :function => :regular,
    :punctuation => :regular,
    :symbol => :math,
    :char => :italic
)

const _default_font_modifiers = Dict(
    :rm => Dict(:bolditalic => :bold, :italic => :regular),
    :it => Dict(:bold => :bolditalic, :regular => :italic),
    :bf => Dict(:italic => :bolditalic, :regular => :bold)
)

const _default_fonts = Dict(
    :regular => joinpath("NewComputerModern", "NewCMMath-Regular.otf"),
    :italic => joinpath("NewComputerModern", "NewCM10-Italic.otf"),
    :bold => joinpath("NewComputerModern", "NewCM10-Bold.otf"),
    :bolditalic => joinpath("NewComputerModern", "NewCM10-BoldItalic.otf"),
    :math => joinpath("NewComputerModern", "NewCMMath-Regular.otf")
)

"""
    FontFamily(fonts ; font_mapping, font_modifiers, special_chars, slant_angle, thickness)

A set of font for LaTeX rendering.

# Required fields
  - `fonts` A with the path to 5 fonts (:regular, :italic, :bold, :bolditalic,
    and :math). The same font can be used for multiple entries, and unrelated
    fonts can be mixed.
    Missing fields are completed with the default fonts from NewComputerModern.

# Optional fields
  - `font_mapping` a dict mapping the different character types (`:digit`,
    `:function`, `:punctuation`, `:symbol`, `:variable`) to a font identifier.
    Default to `MathTeXEngine._default_font_mapping`
  - `font_modifiers` a dict of dict, one entry per font command supported in the
    font set. Each entry is a dict that maps a font identifier to another.
    Default to `MathTeXEngine._default_font_modifiers`.
  - `specail_chars` mapping for special characters that should not be
    represented by their default unicode glyph
    (for example necessary to access the big integral glyph).
  - `slant_angle` the angle by which the italic fonts are slanted, in degree.
  - `thickness` the thickness of the lines associated to the font.
"""
struct FontFamily
    fonts::Dict{Symbol, String}
    font_mapping::Dict{Symbol, Symbol}
    font_modifiers::Dict{Symbol, Dict{Symbol, Symbol}}
    special_chars::Dict{Char, Tuple{String, Int}}
    slant_angle::Float64
    thickness::Float64
end

function FontFamily(fonts ;
        font_mapping = _default_font_mapping,
        font_modifiers = _default_font_modifiers,
        special_chars = Dict{Char, Tuple{String, Int}}(),
        slant_angle = 13,
        thickness = 0.0375)

    fonts = merge(_default_fonts, Dict(fonts))

    return FontFamily(
        fonts,
        font_mapping,
        font_modifiers,
        special_chars,
        slant_angle,
        thickness
    )
end

"""
    FontFamily(name::String = "NewComputerModern")

One of the default set of font for LaTeX rendering.

Currently available are
- NewComputerModern
- TeXGyreHeros
- TeXGyrePagella
- LucioleMath

These names can also be used in a LaTeXString directly,
to set the font of a single string,
with the command `\\fontfamily`,
e.g. L"\\fontfamily{TeXGyreHeros}x^2_3".
"""
FontFamily() = get_texfont_family()
FontFamily(fontname::AbstractString) = default_font_families[fontname]

function Base.show(io::IO, family::FontFamily)
    println(io, "FontFamily with $(family.slant_angle)° slant angle and $(family.thickness) line thickness")
    for (key, font) in family.fonts
        spaces = " "^(12 - length(string(key)))
        println(io, "  $key$spaces=>  $font")
    end
end


# These two fonts internals are very different, despite their similar names
# We only try to fully support NewComputerModern, the other is here as it may
# sometime provide quickfix solution to bug
const default_font_families = Dict(
    "NewComputerModern" => FontFamily(
        Dict(
            :regular => joinpath("NewComputerModern", "NewCMMath-Regular.otf"),
            :italic => joinpath("NewComputerModern", "NewCM10-Italic.otf"),
            :bold => joinpath("NewComputerModern", "NewCM10-Bold.otf"),
            :bolditalic => joinpath("NewComputerModern", "NewCM10-BoldItalic.otf"),
            :math => joinpath("NewComputerModern", "NewCMMath-Regular.otf")
        ),
        special_chars =_symbol_to_new_computer_modern),
    "TeXGyreHeros" => FontFamily(
        Dict(
            :regular => joinpath("TeXGyreHerosMakie", "TeXGyreHerosMakie-Regular.otf"),
            :italic => joinpath("TeXGyreHerosMakie", "TeXGyreHerosMakie-Italic.otf"),
            :bold => joinpath("TeXGyreHerosMakie", "TeXGyreHerosMakie-Bold.otf"),
            :bolditalic => joinpath("TeXGyreHerosMakie", "TeXGyreHerosMakie-BoldItalic.otf"),
            :math => joinpath("TeXGyreHerosMakie", "TeXGyreHerosMakie-Regular.otf")
        )
    ),
    "TeXGyrePagella" => FontFamily(
        Dict(
            :regular => joinpath("TeXGyrePagellaMTE", "TeXGyrePagellaMTE-Regular.otf"),
            :italic => joinpath("TeXGyrePagellaMTE", "TeXGyrePagellaMTE-Italic.otf"),
            :bold => joinpath("TeXGyrePagellaMTE", "TeXGyrePagellaMTE-Bold.otf"),
            :bolditalic => joinpath("TeXGyrePagellaMTE", "TeXGyrePagellaMTE-BoldItalic.otf"),
            :math => joinpath("TeXGyrePagellaMTE", "TeXGyrePagellaMTE-Math.otf"),
        )
    ),
    "LucioleMath" => FontFamily(
        Dict(
            :regular => joinpath("Luciole-Math", "Luciole-Regular.ttf"),
            :italic => joinpath("Luciole-Math", "Luciole-Regular-Italic.ttf"),
            :bold => joinpath("Luciole-Math", "Luciole-Bold.ttf"),
            :bolditalic => joinpath("Luciole-Math", "Luciole-Bold-Italic.ttf"),
            :math => joinpath("Luciole-Math", "Luciole-Math.otf"),
        )
    )
)

const current_texfont_family = Ref(default_font_families["NewComputerModern"])

"""
    get_texfont_family()

Get the current default font family for the styling of LaTeXString.
"""
get_texfont_family() = current_texfont_family[]

"""
    set_texfont_family!([font_family::FontFamily])

Set a font family for the styling of LaTeXString.

See the documentaiton of `FontFamily` for more information.
"""
set_texfont_family!(font_family::FontFamily) = (current_texfont_family[] = font_family)

"""
    set_texfont_family!(; kwargs...)

Set a font family for the styling of LaTeXString,
using key-value to specify individual fonts.

For example, the following sets the regular font
(used for text and function names) to Utopia
(assuming that the Utopia font can be found at the given path).

```julia
set_texfont_family!(regular = "Utopia-Regular.ttf")
```

See the documentation of `FontFamily` for more information.
"""
function set_texfont_family!(; kwargs...)
    if length(kwargs) == 0
        return current_texfont_family[] = default_font_families["NewComputerModern"]
    end
    return set_texfont_family!(FontFamily(kwargs))
end

"""
    get_font([font_family=FontFamily()], fontstyle)

Get the FTFont object representing a font in the given font family. When called
with a single argument uses the default font family.
"""
function get_font(font_family::FontFamily, fontstyle::Symbol)
    return load_font(font_family.fonts[fontstyle])
end
get_font(fontstyle::Symbol) = get_font(FontFamily(), fontstyle)

"""
    texfont(font_desc=:text)

Return the font used by MathTeXEngine.

If a font descriptor is given (e.g. :italic) return the font used for that
scenario.
"""
function texfont(font_desc=:text)
    family = FontFamily()

    haskey(family.fonts, font_desc) && return load_font(family.fonts[font_desc])
    haskey(family.font_mapping, font_desc) && return load_font(family.fonts[family.font_mapping[font_desc]])

    valids = vcat(collect(keys(family.fonts)), collect(keys(family.font_mapping)))
    valids = join([":$sym" for sym in valids], ", ", " and ")
    throw(ArgumentError(
        "Invalid font descriptor $font_desc, valid possibilites are $valids"
    ))
end

"""
    get_fontpath([font_family::FontFamily], fontstyle)

Similar to `get_font` but return the path of the font instead of the FTFont
object.
"""
get_fontpath(font_family::FontFamily, fontstyle::Symbol) = full_fontpath(font_family.fonts[fontstyle])
get_fontpath(fontstyle::Symbol) = get_fontpath(FontFamily(), fontstyle)

is_slanted_font(font_id) = font_id in (:italic, :bolditalic)
is_slanted(font_family, char_type) = is_slanted_font(font_family.font_mapping[char_type])

slant_angle(font_family) = font_family.slant_angle * π / 180

# Few helper functions
"""
    thickness(font::FontFamily)

The thickness of the underline for the given font set.
"""
thickness(font_family::FontFamily) = font_family.thickness

"""
    xheight(font::FontFamily)

The height of the letter x in the given font family, i.e. the height of the letters
without neither ascender nor descender.
"""
xheight(font_family) = inkheight(TeXChar('x', LayoutState(font_family), :text))

struct CanonicalDict{T}
    dict::Dict{T, TeXExpr}
end

CanonicalDict{T}() where T = CanonicalDict(Dict{T, TeXExpr}())

Base.setindex!(d::CanonicalDict, val::TeXExpr, key) = (d.dict[key] = val)
Base.setindex!(d::CanonicalDict{Char}, val::TeXExpr, key::String) = (d[first(key)] = val)

function Base.getindex(d::CanonicalDict, key)
    val = d.dict[key]

    if val isa Char
        return val
    else
        return copy(val)
    end
end

Base.getindex(d::CanonicalDict{Char}, key::String) = d[first(key)]

Base.haskey(d::CanonicalDict, key) = haskey(d.dict, key)
Base.haskey(d::CanonicalDict{Char}, key::String) = haskey(d, first(key))

function Base.get(d::CanonicalDict, key, default)
    haskey(d, key) && return d[key]
    return default
end

# Each symbol or com_str has a unique canonical representation
const symbol_to_canonical = CanonicalDict{Char}()

function canonical_expr(char::Char)
    haskey(symbol_to_canonical, char) && return symbol_to_canonical[char]
    return TeXExpr(:char, char)
end

function get_symbol_char(com_str)
    if !haskey(latex_symbols, com_str)
        @warn "unknown command string $com_str"
        return '?'
    end

    return first(latex_symbols[com_str])
end

##
## Commands
##

function command_expr(com_str, args)
    template = copy(command_definitions[com_str][1])
    return TeXExpr(template.head, vcat(template.args, args))
end
required_args(com_str) = command_definitions[com_str][2]

const command_definitions = Dict(
    raw"\frac" => (TeXExpr(:frac), 2),
    raw"\sqrt" => (TeXExpr(:sqrt), 1),
    raw"\overline" => (TeXExpr(:overline), 1),
    raw"\{" => (TeXExpr(:delimiter, '{'), 0),
    raw"\}" => (TeXExpr(:delimiter, '}'), 0),
    raw"\fontfamily" => (TeXExpr(:fontfamily), 1),
    raw"\glyph" => (TeXExpr(:glyph), 2),
    raw"\unicode" => (TeXExpr(:unicode), 2),
)

for func in underover_functions
    com_str = "\\" * func
    template = TeXExpr(:underover, Any[TeXExpr(:function, func), nothing, nothing])
    command_definitions[com_str] = (template, 0)
end

for func in generic_functions
    com_str = "\\" * func
    command_definitions[com_str] = (TeXExpr(:function, func), 0)
end

for (com_str, width) in space_commands
    command_definitions[com_str] = (TeXExpr(:space, width), 0)
end

for com_str in combining_accents
    combining_char = get_symbol_char(com_str)
    template = TeXExpr(:combining_accent, TeXExpr(:symbol, combining_char))
    command_definitions[com_str] = (template, 1)
end

for name in font_names
    com_str = "\\math$name"
    command_definitions[com_str] = (TeXExpr(:font, Symbol(name)), 1)
    com_str = "\\text$name"
    command_definitions[com_str] = (TeXExpr(:text, Symbol(name)), 1)
end
command_definitions["\\text"] = (TeXExpr(:text, :rm), 1)

##
## Symbols
##

# Symbols missing from the REPL completion data
latex_symbols[raw"\neq"] = "≠"
latex_symbols[raw"\upepsilon"] = "ε"

# Numbers
for char in join(0:9)
    symbol_to_canonical[char] = TeXExpr(:digit, char)
end

for symbol in spaced_symbols
    symbol_expr = TeXExpr(:symbol, symbol)
    symbol_to_canonical[symbol] = TeXExpr(:spaced, symbol_expr)
end

for com_str in spaced_commands
    symbol = get_symbol_char(com_str)
    symbol_expr = TeXExpr(:symbol, symbol)
    template = TeXExpr(:spaced, symbol_expr)
    symbol_to_canonical[symbol] = template
    command_definitions[com_str] = (template, 0)
end

for com_str in underover_commands
    symbol = get_symbol_char(com_str)
    symbol_expr = TeXExpr(:symbol, symbol)
    template = TeXExpr(:underover, Any[symbol_expr, nothing, nothing])
    symbol_to_canonical[symbol] = template
    command_definitions[com_str] = (template, 0)
end

for com_str in integral_commands
    symbol = get_symbol_char(com_str)
    symbol_expr = TeXExpr(:symbol, symbol)
    template = TeXExpr(:integral, Any[symbol_expr, nothing, nothing])
    symbol_to_canonical[symbol] = template
    command_definitions[com_str] = (template, 0)
end

for (symbol, width) in space_symbols
    symbol_to_canonical[symbol] = TeXExpr(:space, width)
end

for symbol in punctuation_symbols
    symbol = first(symbol)
    symbol_to_canonical[symbol] = TeXExpr(:punctuation, symbol)
end

for symbol in delimiter_symbols
    symbol = first(symbol)
    symbol_to_canonical[symbol] = TeXExpr(:delimiter, symbol)
end

##
## Default behavior
##
# We put it at the end to avoid overwritting existing commands

for (com_str, symbol) in latex_symbols
    symbol = first(symbol)  # Convert String to Char
    symbol_expr = TeXExpr(:symbol, symbol)

    if !haskey(symbol_to_canonical, symbol)
        symbol_to_canonical[symbol] = symbol_expr
    end

    # Separate case for symbols that have multiple valid commands
    if !haskey(command_definitions, com_str)
        command_definitions[com_str] = (symbol_expr, 0)
    end
end

"""
    TeXElement

Abstract super type for elements of a MathTeX string.

Currently represent either
    - a char
    - a space
    - a horizontal or vertical line
    - a group of TeXElements positioned relative to each other
"""
abstract type TeXElement end

"""
    leftinkbound(elem::TeXElement)

Return the position of the leftmost position the ink of the element uses.
"""
function leftinkbound end

"""
    rightinkbound(elem::TeXElement)

Return the position of the rightmost position the ink of the element uses.
"""
function rightinkbound end

"""
    bottominkbound(elem::TeXElement)

Return the position of the lowest position the ink of the element uses.
"""
function bottominkbound end

"""
    topinkbound(elem::TeXElement)

Return the position of the highest position the ink of the element uses.
"""
function topinkbound end

"""
    hadvance(elem::TeXElement)

Return the horizontal distance between the origin of the element and the origin of the
next element to be drawn, without kerning.
"""
hadvance(x::TeXElement) = inkwidth(x)

"""
    ascender(elem::TeXElement)

Return the vertical spaced reserved above the element, measured from the
baseline.

Only makes sense for TeXChar and derived elements, is set to zero for all other
for convenience.
"""
ascender(x::TeXElement) = 0

"""
    descender(elem::TeXElement)

Return the vertical spaced reserved below the element, measured from the
baseline.

Only makes sense for TeXChar and derived elements, is set to zero for all other
for convenience.
"""
descender(x::TeXElement) = 0

"""
    xheight(elem::TeXElement)

Return the height of the 'x' character associated to the font of the element.

Only makes sense for TeXChar and derived elements, is set to zero for all other
for convenience.
"""
xheight(x::TeXElement) = 0

"""
    hmid(elem::TeXElement)

Return the horizontal middle of the element ink.
"""
hmid(x::TeXElement) = 0.5*(leftinkbound(x) + rightinkbound(x))

"""
    vmid(elem::TeXElement)

Return the vertical middle of the element ink.
"""
vmid(x::TeXElement) = 0.5*(bottominkbound(x) + topinkbound(x))

"""
    inkwidth(elem::TeXElement)

Return the total width of the element ink.
"""
inkwidth(x::TeXElement) = rightinkbound(x) - leftinkbound(x)

"""
    inkheight(elem::TeXElement)

Return the total height of the element ink.
"""
inkheight(x::TeXElement) = topinkbound(x) - bottominkbound(x)

"""
    is_slanted(x::TeXElement)

Return whether the given element is slanted.
"""
is_slanted(x::TeXElement) = false

slant_angle(x::TeXElement) = 0.0
leftmost_glyph(x::TeXElement) = x
rightmost_glyph(x::TeXElement) = x

"""
    TeXChar(char, font)

A MathTeX character with an associated font.

TeXChar implement all functions defined for FreeTypeAbstraction.FontExtents
and can be used instead to get all geometric information about the
character.

This is especially useful since for fonts that require some adjustement for the
proper positioning of math symbols.

Fields
======
    - glyph_id::Culong The ID of the glyph representing the char in
        the associated font.
    - font::FTFont The font that should be used to display this character.
    - font_family::FontFamily The font family of the character.
    - slanted::Bool Whether this char is considered italic.
    - represented_char::Char The char represented by this char.
        Different from char for in some cases.
"""
struct TeXChar <: TeXElement
    glyph_id::Culong
    font::FTFont
    font_family::FontFamily
    slanted::Bool
    represented_char::Char
end

function TeXChar(char::Char, state::LayoutState, char_type)
    font_family = state.font_family

    if haskey(font_family.special_chars, char)
        fontpath, id = font_family.special_chars[char]
        font = load_font(fontpath)
        return TeXChar(id, font, font_family, false, char)
    end

    font = get_font(state, char_type)

    return TeXChar(
        glyph_index(font, char),
        font,
        font_family,
        is_slanted(state.font_family, char_type),
        char)
end

function TeXChar(name::AbstractString, state::LayoutState, char_type ; represented='?')
    font_family = state.font_family
    font = get_font(state, char_type)
    return TeXChar(
        glyph_index(font, name),
        font,
        font_family,
        is_slanted(state.font_family, char_type),
        represented)
end

for inkfunc in (:leftinkbound, :rightinkbound, :bottominkbound, :topinkbound)
    @eval $inkfunc(char::TeXChar) = $inkfunc(get_extent(char.font, char.glyph_id))
end

glyph_index(char::TeXChar) = char.glyph_id
hadvance(char::TeXChar) = hadvance(get_extent(char.font, char.glyph_id))
xheight(char::TeXChar) = xheight(char.font_family)

function ascender(char::TeXChar)
    math_font = get_font(char.font_family, :math)
    return max(ascender(math_font), topinkbound(char))
end

function descender(char::TeXChar)
    math_font = get_font(char.font_family, :regular)
    return min(descender(math_font), bottominkbound(char))
end

function FreeTypeAbstraction.height_insensitive_boundingbox(char::TeXChar, font)
    return Rect2f(
        leftinkbound(char), descender(char),
        inkwidth(char), ascender(char) - descender(char)
    )
end

is_slanted(char::TeXChar) = char.slanted
slant_angle(char::TeXChar) = slant_angle(char.font_family)

Base.show(io::IO, tc::TeXChar) =
    print(io, "TeXChar '$(tc.represented_char)' [index $(tc.glyph_id) in $(tc.font.family_name) - $(tc.font.style_name)]")


"""
    Space

A MathTeX space of a given width.

Fields
======
    - width::Real The width of the space.
"""
struct Space{T} <: TeXElement
    width::T
end

leftinkbound(::Space) = 0
rightinkbound(s::Space) = s.width
bottominkbound(::Space) = 0
topinkbound(::Space) = 0

"""
    Vline

A vertical line.

Fields
======
    - height::Real The span of the line in the vertical direction.
    - thickness::Real The thickness of the line.
"""
struct VLine{T} <: TeXElement
    height::T
    thickness::T
end

VLine(height, thickness) = VLine(promote(height, thickness)...)

leftinkbound(line::VLine) = -line.thickness/2
rightinkbound(line::VLine) = line.thickness/2
bottominkbound(line::VLine{T}) where T = min(line.height, zero(T))
topinkbound(line::VLine{T}) where T = max(line.height, zero(T))

"""
    Hline

A horizontal line.

Fields
======
    - width::Real The span of the line in the horizontal direction.
    - thickness::Real The thickness of the line.
"""
struct HLine{T} <: TeXElement
    width::T
    thickness::T
end

HLine(height, thickness) = HLine(promote(height, thickness)...)

leftinkbound(line::HLine{T}) where T = min(line.width, zero(T))
rightinkbound(line::HLine{T}) where T = max(line.width, zero(T))
bottominkbound(line::HLine) = -line.thickness/2
topinkbound(line::HLine) = line.thickness/2

"""
    Group

A group of TeXElements.

Positions and scales are relative to the group.

Fields
======
    - elements::Vector{<:TeXElement} Vector of the elements contained in the group.
    - positions::Vector{Point2f} Vector of the relative positions of the contained elements.
    - scales::Vector Vector of the relative scales of the contained elements.
"""
struct Group{T} <: TeXElement
    elements::Vector{<:TeXElement}
    positions::Vector{Point2f}
    scales::Vector{T}
end

Group(elements, positions) = Group(elements, positions, ones(length(elements)))

xpositions(g::Group) = [p[1] for p in g.positions]
ypositions(g::Group) = [p[2] for p in g.positions]

function leftinkbound(g::Group)
    lefts = leftinkbound.(g.elements) .* g.scales .+ xpositions(g)
    return minimum(lefts)
end

function rightinkbound(g::Group)
    rights = rightinkbound.(g.elements) .* g.scales .+ xpositions(g)
    return maximum(rights)
end

function bottominkbound(g::Group)
    bottoms = bottominkbound.(g.elements) .* g.scales .+ ypositions(g)
    return minimum(bottoms)
end

function topinkbound(g::Group)
    tops = topinkbound.(g.elements) .* g.scales .+ ypositions(g)
    return maximum(tops)
end

function hadvance(g::Group)
    adv = xpositions(g) .+ hadvance.(g.elements) .* g.scales
    return maximum(adv)
end

function ascender(g::Group)
    asc = ypositions(g) .+ ascender.(g.elements) .* g.scales
    return maximum(asc)
end

function descender(g::Group)
    des = ypositions(g) .+ descender.(g.elements) .* g.scales
    return minimum(des)
end

xheight(g::Group) = maximum(xheight.(g.elements) .* g.scales)

leftmost_glyph(g::Group) = leftmost_glyph(first(g.elements))
rightmost_glyph(g::Group) = rightmost_glyph(last(glyph))

using Pkg

Pkg.activate("prototype")

using MathTeXEngine
using CairoMakie
using Colors
using GeometryBasics
using LaTeXStrings

import MathTeXEngine: TeXChar, VLine, HLine, leftinkbound, descender, inkwidth,
    topinkbound, hadvance, bottominkbound, rightinkbound, ascender,
    height_insensitive_boundingbox

draw_texelement!(args... ; size=64) = nothing

function draw_texelement!(ax, texchar::TeXChar, position, scale ; size=64)
    x = position[1] * size
    y = position[2] * size
    # TODO This doesn't make sense anymore
    text!(ax, string(Char(texchar.represented_char)), font=texchar.font,
        position=Point2f(x, y),
        fontsize=size*scale,
        space=:data,
        markerspace=:data,
        align=(:left, :baseline),
        offset=(0, 0))
end

function draw_texelement!(ax, line::VLine, position, scale ; size=64)
    lw = line.thickness * scale / 2
    xmid, y0 = position
    x0 = xmid - lw
    x1 = xmid + lw
    y1 = y0 + line.height * scale
    points = Point2f[(x0, y0), (x0, y1), (x1, y1), (x1, y0)]
    poly!(ax, points .* size, color=:black, shading=false)
end

function draw_texelement!(ax, line::HLine, position, scale ; size=64)
    lw = line.thickness * scale / 2
    x0, ymid = position
    x1 = x0 + line.width * scale
    y0 = ymid - lw
    y1 = ymid + lw
    points = Point2f[(x0, y0), (x0, y1), (x1, y1), (x1, y0)]
    poly!(ax, points .* size, color=:black, shading=false)
end

draw_texelement_helpers!(args... ; size=64) = nothing

# TODO Move helper rect to the module
function draw_texelement_helpers!(ax, texchar::TeXChar, position, scale ; size=64)
    x = position[1] * size
    # Characters are drawn from the bottom left of the font bounding box but
    # their position is relative to the baseline, so we need to offset them
    y = position[2] * size
    w = inkwidth(texchar) * size * scale
    a = hadvance(texchar) * size * scale
    top = topinkbound(texchar) * size * scale
    bottom = bottominkbound(texchar) * size * scale
    left = leftinkbound(texchar) * size * scale
    right = rightinkbound(texchar) * size * scale

    hbbox = height_insensitive_boundingbox(texchar, nothing)
    asc = (origin(hbbox)[2] + widths(hbbox)[2]) * size * scale
    desc = origin(hbbox)[2] * size * scale

    # asc = ascender(texchar) * size * scale
    # desc = descender(texchar) * size * scale

    # The space between th origin and the left ink bound
    poly!(ax,
        Point2f[
            (x, y + bottom),
            (x + left, y + bottom),
            (x + left, y + top),
            (x, y + top)
        ],
        color=RGBA(1, 1, 0, 0.6),
        shading=false
    )

    # The advance after the right inkbound
    poly!(ax,
        Point2f[
            (x + right, y + bottom),
            (x + a, y + bottom),
            (x + a, y + top),
            (x + right, y + top)
        ],
        color=RGBA(0, 1, 0, 0.3),
        shading=false
    )

    # The descender
    poly!(ax,
        Point2f[
            (x + left, y),
            (x + right, y),
            (x + right, y + bottom),
            (x + left, y + bottom)
        ],
        color=RGBA(0, 0, 1, 0.3),
        shading=false
    )

    # The inkbound above the baseline
    poly!(ax,
        Point2f[
            (x + left, y),
            (x + right, y),
            (x + right, y + top),
            (x + left, y + top)
        ],
        color=RGBA(1, 0, 0, 0.5),
        shading=false
    )

    # Descender
    lines!(ax,
        [x + left, x + a],
        [y + desc, y + desc],
        color=:green
    )

    # Ascender
    lines!(ax,
        [x + left, x + a],
        [y + asc, y + asc],
        color=:blue
    )
end

function makie_tex!(
        ax, latex::LaTeXString ;
        debug = false,
        size = 64,
        position = [0, 0],
        fontfamily = FontFamily())

    for (elem, pos, scale) in generate_tex_elements(latex, fontfamily)
        draw_texelement!(ax, elem, pos .+ position, scale ; size=size)
        if debug
            draw_texelement_helpers!(ax, elem, pos .+ position, scale ; size=size)
        end
    end
end

begin  # Quick test
    fig = Figure(size=(1800, 1000))
    fig[1, 1] = Label(fig, "LaTeX in Makie.jl", tellwidth=false, fontsize=64)
    ax = Axis(fig[2, 1])
    hidedecorations!(ax)
    ax.aspect = DataAspect()
    tex = L"\nabla 3\degree \partial L^3 \sum \lim_{L →\infty}
            \frac{\varphi \phi \varpi}{\pi \varepsilon \epsilon}
            ℝ^\sqrt{A + j + 2 + 3} |x^2|^3 = \sum_{k = 1}^N
            \vec{v}_{(a' + \bar{a})_k} + \sqrt{T} x! \quad \mathrm{when} \quad
            \left[ \sqrt{\frac{\Omega-2}{a \langle c^\dagger \rangle b}} \right]^3_3 
            < \int_{0}^{2π} |\sin(\mu x)| dx"
    
    # tex = L"\mathcal{A} \mathbb{R} \longrightarrow xyz \text{x y z} \mathrm{x y z}"
    # tex = L"$p_z$ ($10^5$ a. u.)"

    makie_tex!(ax, tex, size=64, fontfamily = FontFamily("TeXGyreHeros"))
    fig[3, 1] = Label(fig, tex, tellwidth=false, tellheight=false, fontsize=40)
    fig
end

"""
Return the y value needed for the element to be vertically centered in the
middle of the xheight.
"""
function y_for_centered(font_family, elem)
    h = inkheight(elem)
    return h / 2 + xheight(font_family) / 2
end

function argument_as_string(arg)
    return String(Char.(arg.args))
end

const _TEXT_OPERATOR_SPACE = 0.2
const _SCRIPT_OPERATOR_SPACE = 0.08
const _MIN_SCRIPT_GAP = 0.04
const _TALL_SCRIPT_CORE_HEIGHT = 1.2
const _TALL_SCRIPT_VERTICAL_CLEARANCE = 0.65
const _TALL_SCRIPT_CORE_OVERLAP = 0.3
const _FRACTION_RULE_PADDING = 0.65
const _SCRIPT_FRACTION_RULE_WIDTH = 0.45
const _SCRIPT_FRACTION_RULE_SHIFT = 0.18
const _TALL_SCRIPT_HEIGHT_FACTOR = 1.5
const _SCRIPT_SHRINK_HEIGHT_FACTOR = 1.5
const _SQRT_RULE_CONTENT_DESCENT = 0.25
const _SQRT_TALL_CONTENT_DESCENT = 0.25
const _SQRT_TALL_CONTENT_HEIGHT = 1.75
const _SQRT_MAX_RADICAL_STRETCH = 1.25
const _SQRT_MAX_BASE_RADICAL_HEIGHT = 1.4
const _SQRT_SHORT_CONTENT_HEIGHT = 1.15
const _SQRT_SHORT_CONTENT_MAX_DESCENT = 0.45
const _SQRT_SIMPLE_CONTENT_HEIGHT_FACTOR = 1.05
const _SQRT_RULE_PADDING = 0.12
const _SQRT_TRAILING_PADDING = 0.06
const _SLANTED_ADJACENT_GAP = 0.03
const _LATIN_ITALIC_PAIR_GAP = 0.08
const _DIGIT_ITALIC_LEFT_BEARING_CORRECTION = 0.5
const _DISPLAY_OPERATOR_DELIMITER_HEIGHT = 1.35
const _BRACE_RULE_AXIS_PADDING = 0.2

function _script_y_positions(core, sub, super, font_family, sub_shrink, super_shrink)
    xh = xheight(font_family)
    script_gap = max(thickness(font_family), _MIN_SCRIPT_GAP)
    tall_script_height = _TALL_SCRIPT_HEIGHT_FACTOR * xh

    sub_y = -0.2
    if _has_rule_element(sub) || inkheight(sub) * sub_shrink > tall_script_height
        sub_y = min(sub_y, -topinkbound(sub) * sub_shrink - script_gap)
    end

    super_y = xh
    if _has_rule_element(super) || inkheight(super) * super_shrink > tall_script_height
        super_y = max(super_y, -bottominkbound(super) * super_shrink + xh + script_gap)
    end
    super_y -= max(bottominkbound(super), 0) * super_shrink

    if inkheight(core) > _TALL_SCRIPT_CORE_HEIGHT
        sub_top = bottominkbound(core) + _TALL_SCRIPT_VERTICAL_CLEARANCE * xh
        super_bottom = topinkbound(core) - _TALL_SCRIPT_VERTICAL_CLEARANCE * xh
        sub_y = min(sub_y, sub_top - topinkbound(sub) * sub_shrink)
        super_y = max(super_y, super_bottom - bottominkbound(super) * super_shrink)
    end

    return sub_y, super_y
end

function _script_shrink(elem, font_family, shrink)
    is_tall_script =
        _has_rule_element(elem) ||
        inkheight(elem) * shrink > _SCRIPT_SHRINK_HEIGHT_FACTOR * xheight(font_family)
    return is_tall_script ? 0.5 : shrink
end

function _subscript_x_position(core, font_family, tall_core)
    script_edge = is_slanted(core) ? hadvance(core) : max(hadvance(core), rightinkbound(core))
    if tall_core
        script_edge -= _TALL_SCRIPT_CORE_OVERLAP * xheight(font_family)
    end

    return script_edge
end

function _superscript_x_position(core, font_family, tall_core)
    script_edge = max(hadvance(core), rightinkbound(core))
    if tall_core
        script_edge -= _TALL_SCRIPT_CORE_OVERLAP * xheight(font_family)
    end

    return script_edge
end

function _fraction_rule_width(argument_width, font_family, script_level)
    if script_level > 0
        return _SCRIPT_FRACTION_RULE_WIDTH * argument_width
    end

    return argument_width + _FRACTION_RULE_PADDING * xheight(font_family)
end

function _has_rule_element(elem)
    elem isa Union{HLine, VLine} && return true
    if elem isa Group
        return any(_has_rule_element, elem.elements)
    end

    return false
end

const _sqrt_radical_name_sets = (
    ("radical.v1", "radical.v2", "radical.v3", "radical.v4", "radical.v5", "radical.v6"),
    ("sqrt.v1", "sqrt.v2", "sqrt.v3", "sqrt.v4"),
)

function _sqrt_radical_variants(state)
    radicals = TeXElement[]

    # Constructed square roots need size-specific radical glyphs. Ordinary
    # Unicode √ glyphs vary too much across fonts to be used as extenders.
    for radical_names in _sqrt_radical_name_sets
        for radical_name in radical_names
            candidate = TeXChar(radical_name, state, :symbol; represented = '√')
            if candidate.glyph_id != 0 && inkheight(candidate) > 0
                push!(radicals, candidate)
            end
        end
    end

    sort!(radicals; by = inkheight)
    return radicals
end

function _base_sqrt_radical(state)
    radical = TeXChar('√', state, :symbol)
    if radical.glyph_id != 0 && inkheight(radical) > 0
        return radical
    end

    return nothing
end

function _fallback_sqrt_radical_variants(font_family)
    radicals = TeXElement[]

    for radical_name in first(_sqrt_radical_name_sets)
        radical = default_math_texchar(radical_name, font_family, '√')
        isnothing(radical) || push!(radicals, radical)
    end

    # Last-resort fallback for custom builds where the default radical variants
    # are unavailable. The bundled fonts provide the named variants above.
    if isempty(radicals)
        radical = default_math_texchar('√', font_family, '√')
        isnothing(radical) || push!(radicals, radical)
    end

    sort!(radicals; by = inkheight)
    return radicals
end

function _has_compact_base_radical(radicals)
    isempty(radicals) && return false
    return inkheight(first(radicals)) <= _SQRT_MAX_BASE_RADICAL_HEIGHT
end

function _with_base_sqrt_radical(state, radicals)
    base_radical = _base_sqrt_radical(state)
    isnothing(base_radical) && return radicals

    candidates = TeXElement[base_radical]
    append!(candidates, radicals)
    sort!(candidates; by = inkheight)
    return candidates
end

function _select_sqrt_radical(radicals, target_height)
    previous = nothing
    for candidate in radicals
        if inkheight(candidate) >= target_height
            if !isnothing(previous)
                stretch = target_height / inkheight(previous)
                stretch <= _SQRT_MAX_RADICAL_STRETCH && return previous, stretch
            end

            return candidate, 1.0
        end

        previous = candidate
    end

    if isempty(radicals)
        return nothing
    end

    radical = last(radicals)
    return radical, max(1.0, target_height / inkheight(radical))
end

function _sqrt_radical_candidates(state, content)
    radicals = _sqrt_radical_variants(state)
    if !_has_compact_base_radical(radicals)
        radicals = _fallback_sqrt_radical_variants(state.font_family)
    end

    if !_has_rule_element(content)
        if _is_tall_sqrt_content(content, state.font_family)
            taller_radicals = filter(radical -> inkheight(radical) > 1, radicals)
            isempty(taller_radicals) || return taller_radicals
        end

        return _with_base_sqrt_radical(state, radicals)
    end

    return radicals
end

function _sqrt_radical(state, target_height, content)
    radical = _select_sqrt_radical(_sqrt_radical_candidates(state, content), target_height)
    isnothing(radical) || return radical

    radical = _select_sqrt_radical(_fallback_sqrt_radical_variants(state.font_family), target_height)
    isnothing(radical) || return radical

    throw(ArgumentError("No square-root radical glyph found"))
end

_is_tall_sqrt_content(content, font_family) =
    topinkbound(content) > _SQRT_TALL_CONTENT_HEIGHT * xheight(font_family)

const _math_delimiter_chars = Set(['(', ')', '[', ']', '{', '}', '⟨', '⟩', '|', '‖'])
const _display_operator_chars = Set(['∫', '∑', '∏'])
const _delimiter_axis_operator_chars =
    Set(['+', '-', '−', '±', '∓', '×', '⋅', '=', '<', '>', '≤', '≥', '≠'])

function _delimiter_element(char, state)
    font_family = state.font_family

    if char in _math_delimiter_chars
        texchar = default_math_texchar(char, font_family, char)
        if !isnothing(texchar)
            return texchar
        end
    end

    return TeXChar(char, state, :delimiter)
end

function _is_brace_delimiter(delimiter)
    return delimiter isa TeXChar && delimiter.represented_char in ('{', '}')
end

function _delimiter_target_height(content, content_axis, delimiter, font_family)
    n_visible, elem = _count_visible_nondelimiters(content)
    if n_visible == 1
        if elem isa TeXChar && elem.represented_char in _display_operator_chars
            return min(inkheight(content), _DISPLAY_OPERATOR_DELIMITER_HEIGHT)
        end
    end

    height = inkheight(content)
    if _has_rule_element(content)
        axis_height = 2max(
            content_axis - bottominkbound(content),
            topinkbound(content) - content_axis,
        )
        if _is_brace_delimiter(delimiter)
            axis_height = min(
                axis_height,
                height + _BRACE_RULE_AXIS_PADDING * xheight(font_family),
            )
        end
        return max(height, axis_height)
    end

    return height
end

function _count_visible_nondelimiters(elem)
    elem isa Space && return 0, nothing

    if elem isa Group
        n_visible = 0
        only_visible = nothing
        for child in elem.elements
            n_child, child_visible = _count_visible_nondelimiters(child)
            n_visible += n_child
            if n_child == 1
                only_visible = child_visible
            end
            n_visible > 1 && return n_visible, nothing
        end
        return n_visible, only_visible
    end

    if elem isa TeXChar && elem.represented_char in _math_delimiter_chars
        return 0, nothing
    end

    return 1, elem
end

function _delimiter_visual_bounds(elem)
    elem isa Space && return nothing
    elem isa Union{HLine, VLine} && return nothing

    if elem isa TeXChar
        elem.represented_char in _math_delimiter_chars && return nothing
        elem.represented_char in _delimiter_axis_operator_chars && return nothing
        return bottominkbound(elem), topinkbound(elem)
    end

    if elem isa Group
        bottom = Inf
        top = -Inf
        for (child, position, scale) in zip(elem.elements, elem.positions, elem.scales)
            child_bounds = _delimiter_visual_bounds(child)
            isnothing(child_bounds) && continue

            child_bottom, child_top = child_bounds
            bottom = min(bottom, position[2] + scale * child_bottom)
            top = max(top, position[2] + scale * child_top)
        end

        isinf(bottom) && return nothing
        return bottom, top
    end

    return bottominkbound(elem), topinkbound(elem)
end

function _delimiter_axis(content, font_family)
    axis = max(vmid(content), xheight(font_family) / 2)
    _has_rule_element(content) && return axis

    bounds = _delimiter_visual_bounds(content)
    isnothing(bounds) && return axis

    visual_axis = (bounds[1] + bounds[2]) / 2
    return max(axis, visual_axis)
end

function _sqrt_clearance(content, font_family)
    xh = xheight(font_family)
    clearance = xh / 2
    return max(thickness(font_family), clearance)
end

function _simple_sqrt_line_top(content, radical, radical_scale, clearance)
    line_top = topinkbound(content) + clearance
    radical_height = radical_scale * inkheight(radical)
    content_height = inkheight(content)
    pad = max((radical_height - _SQRT_SIMPLE_CONTENT_HEIGHT_FACTOR * content_height) / 2, 0.0)
    centered_line_top = bottominkbound(content) + radical_height - pad
    return max(line_top, centered_line_top)
end

function _short_sqrt_radical_scale(content, radical, radical_scale, clearance, font_family)
    content_height = inkheight(content)
    if content_height <= 0 || content_height > _SQRT_SHORT_CONTENT_HEIGHT * xheight(font_family)
        return radical_scale
    end

    radical_height = radical_scale * inkheight(radical)
    line_top = _simple_sqrt_line_top(content, radical, radical_scale, clearance)
    root_descent = bottominkbound(content) - (line_top - radical_height)
    max_descent = _SQRT_SHORT_CONTENT_MAX_DESCENT * xheight(font_family)
    root_descent <= max_descent && return radical_scale

    max_height = min(
        2max_descent + _SQRT_SIMPLE_CONTENT_HEIGHT_FACTOR * content_height,
        max_descent + content_height + clearance,
    )
    return min(radical_scale, max_height / inkheight(radical))
end

"""
    tex_layout(mathexpr::TeXExpr, font_family)

Recursively determine the layout of the math expression represented the given
TeXExpr for the given font set.

Return a set of nested objects, positioned and scaled relative to their parent.
"""
tex_layout(expr, font_family::FontFamily) = tex_layout(expr, LayoutState(font_family))

function tex_layout(expr, state)
    font_family = state.font_family
    head = expr.head
    args = [expr.args...]
    shrink = 0.6
    italic_correction = state.tex_mode == :inline_math && italic_correction_enabled[]

    try
        if isleaf(expr)  # :char, :delimiter, :digit, :punctuation, :symbol
            char = args[1]
            if char == ' ' && state.tex_mode == :inline_math
                return Space(0.0)
            elseif head == :delimiter
                return _delimiter_element(char, state)
            end
            return TeXChar(char, state, head)
        elseif head == :combining_accent
            accent, core = tex_layout.(args, state)

            # Same space between the top of core and the accent than
            # between the top of a 'x' and the accent
            y = topinkbound(core) - xheight(font_family)

            if core.slanted
                α = slant_angle(font_family)
                x = (y + bottominkbound(accent)) * tan(α) / 2
            else
                x = 0.0
            end

            return Group(
                [core, accent],
                Point2f[(0, 0), (x + hmid(core) - hmid(accent), y)],
                [1, 1];
                slanted = is_slanted(core),
            )
        elseif head == :decorated
            core = tex_layout(args[1], state)
            script_state = increase_script_level(state)
            sub = tex_layout(args[2], script_state)
            super = tex_layout(args[3], script_state)

            sub_shrink = _script_shrink(sub, font_family, shrink)
            super_shrink = _script_shrink(super, font_family, shrink)
            tall_core = inkheight(core) > _TALL_SCRIPT_CORE_HEIGHT
            sub_y, super_y = _script_y_positions(
                core,
                sub,
                super,
                font_family,
                sub_shrink,
                super_shrink,
            )
            if !isnothing(args[3]) && args[3].head == :primes
                super_x = min(hadvance(core), rightinkbound(core)) - 0.1
                super_y = 0.1
                super_shrink = 1
            else
                super_x = _superscript_x_position(
                    core,
                    font_family,
                    tall_core,
                )
            end
            sub_x = _subscript_x_position(
                core,
                font_family,
                tall_core,
            )

            return Group(
                [core, sub, super],
                Point2f[
                    (0, 0),
                    (sub_x, sub_y),
                    (super_x, super_y),
                ],
                [1, sub_shrink, super_shrink];
                slanted = is_slanted(core) || is_slanted(super),
            )
        elseif head == :delimited
            elements = tex_layout.(args, state)
            left, content, right = elements

            content_midline = _delimiter_axis(content, font_family)
            left_height = _delimiter_target_height(content, content_midline, left, font_family)
            right_height = _delimiter_target_height(content, content_midline, right, font_family)
            left_scale = max(1, left_height / inkheight(left))
            right_scale = max(1, right_height / inkheight(right))
            scales = [left_scale, 1, right_scale]

            dxs = hadvance.(elements) .* scales
            xs = [0, cumsum(dxs[1:(end - 1)])...]

            return Group(
                elements,
                Point2f[
                    (xs[1], content_midline - vmid(left) * left_scale),
                    (xs[2], 0),
                    (xs[3], content_midline - vmid(right) * right_scale),
                ],
                scales;
                slanted = is_slanted(right),
            )
        elseif head == :font
            modifier, content = args
            return tex_layout(content, add_font_modifier(state, modifier))
        elseif head == :fontfamily
            return Space(0)
        elseif head == :frac
            numerator = tex_layout(args[1], state)
            denominator = tex_layout(args[2], state)

            xh = xheight(font_family)
            argument_left = min(leftinkbound(numerator), leftinkbound(denominator))
            argument_right = max(rightinkbound(numerator), rightinkbound(denominator))
            argument_width = argument_right - argument_left
            rule_width = _fraction_rule_width(argument_width, font_family, state.script_level)

            # fixed width fraction line
            rule_thickness = thickness(font_family)

            line = HLine(rule_width, rule_thickness)
            y0 = xh / 2 - rule_thickness / 2

            # Align the rule and arguments around the same center. This matters
            # for shortened script-style rules, where anchoring at x = 0 makes
            # the rule look too long on one side.
            center = (argument_left + argument_right) / 2
            xline = center - hmid(line)
            if state.script_level > 0
                xline -= _SCRIPT_FRACTION_RULE_SHIFT * argument_width
            end
            x1 = center - hmid(numerator)
            x2 = center - hmid(denominator)

            ytop = y0 + xh / 2 - bottominkbound(numerator)
            ybottom = y0 - xh / 2 - topinkbound(denominator)

            elements = [line, numerator, denominator]
            positions = Point2f[(xline, y0), (x1, ytop), (x2, ybottom)]
            fraction_left = minimum(
                position[1] + leftinkbound(element) for
                    (element, position) in zip(elements, positions)
            )
            if fraction_left < 0
                positions = positions .+ Ref(Point2f(-fraction_left, 0))
            end

            return Group(
                elements,
                positions;
                slanted = is_slanted(numerator) || is_slanted(denominator),
            )
        elseif head == :function
            name = args[1]
            elements = TeXChar.(collect(name), state, Ref(:function))
            return horizontal_layout(elements; italic_correction)
        elseif head == :glyph
            font_id, glyph_id = argument_as_string.(args)
            font_id = Symbol(font_id)
            glyph_id = parse(Culong, glyph_id)
            font = get_font(state.font_family, font_id)
            return TeXChar(glyph_id, font, state.font_family, false, '?')
        elseif head in (:group, :inline_math, :line)
            mode = (head == :inline_math) ? :inline_math : state.tex_mode
            child_state = change_mode(state, mode)
            elements = tex_layout.(args, child_state)
            if isempty(elements)
                return Space(0.0)
            end

            if mode == :inline_math
                elements = _add_math_operator_spacing(args, elements)
            end

            italic_correction = mode == :inline_math && italic_correction_enabled[]
            return horizontal_layout(elements; italic_correction)
        elseif head == :integral
            pad = 0.1
            int, sub, super = tex_layout.(args, state)

            return Group(
                [int, sub, super],
                Point2f[
                    (0, 0),
                    (
                        0.15 - inkwidth(sub) * shrink / 2,
                        bottominkbound(int) - topinkbound(sub) * shrink - pad,
                    ),
                    (0.85 - inkwidth(super) * shrink / 2, topinkbound(int) + pad),
                ],
                [1, shrink, shrink];
                slanted = is_slanted(int),
            )
        elseif head == :lines
            length(args) == 1 && return tex_layout(only(args), state)
            lineheight = 1.3
            lines = tex_layout.(args, state)
            points = map(enumerate(lines)) do (k, line)
                x = -inkwidth(line) / 2
                y = (1 - k) * lineheight
                return Point2f(x, y)
            end

            return Group(lines, points)
        elseif head == :overline
            content = tex_layout(args[1], state)

            lw = thickness(font_family)
            y = topinkbound(content) - lw

            hline = HLine(inkwidth(content) - 0.15, lw)

            return Group(
                [hline, content],
                Point2f[(0.25, y + lw / 2 + 0.2), (0, 0)];
                slanted = is_slanted(content),
            )
        elseif head == :primes
            primes = [TeXExpr(:char, ''') for _ in 1:only(args)]
            return horizontal_layout(tex_layout.(primes, state); italic_correction)
        elseif head == :space
            return Space(args[1])
        elseif head == :spaced
            sym = tex_layout(args[1], state)
            space = state.script_level > 0 ? _SCRIPT_OPERATOR_SPACE : _TEXT_OPERATOR_SPACE
            return horizontal_layout([Space(space), sym, Space(space)]; italic_correction)
        elseif head == :sqrt
            content = tex_layout(args[1], state)
            rule_thickness = thickness(font_family)
            xh = xheight(font_family)
            clearance = _sqrt_clearance(content, font_family)
            line_top = topinkbound(content) + clearance
            if _has_rule_element(content)
                desired_bottom = bottominkbound(content) - _SQRT_RULE_CONTENT_DESCENT * xh
                target_height = max(inkheight(content), line_top - desired_bottom)
            elseif _is_tall_sqrt_content(content, font_family)
                desired_bottom = bottominkbound(content) - _SQRT_TALL_CONTENT_DESCENT * xh
                target_height = max(inkheight(content), line_top - desired_bottom)
            else
                target_height = inkheight(content)
            end
            radical, radical_scale = _sqrt_radical(state, target_height, content)

            if _has_rule_element(content)
                radical_bottom = bottominkbound(content) - _SQRT_RULE_CONTENT_DESCENT * xh
                line_top = max(line_top, radical_bottom + radical_scale * inkheight(radical))
            elseif !_is_tall_sqrt_content(content, font_family)
                radical_scale = _short_sqrt_radical_scale(
                    content,
                    radical,
                    radical_scale,
                    clearance,
                    font_family,
                )
                line_top = _simple_sqrt_line_top(content, radical, radical_scale, clearance)
            end
            y0 = line_top - radical_scale * topinkbound(radical)
            line_y = line_top - rule_thickness / 2

            hline_width =
                max(rightinkbound(content), xheight(font_family) / 2) +
                _SQRT_RULE_PADDING * xh +
                rule_thickness
            hline = HLine(hline_width, rule_thickness)
            radical_right = radical_scale * rightinkbound(radical)
            hline_x = radical_right - rule_thickness / 2
            hline_right = hline_x + rightinkbound(hline)
            content_right = rightinkbound(content)
            target_hadvance = hline_right + _SQRT_TRAILING_PADDING * xh
            trailing_space_x = min(content_right, target_hadvance)
            trailing_space = target_hadvance - trailing_space_x

            return Group(
                [radical, hline, content, Space(trailing_space)],
                Point2f[
                    (0, y0),
                    (hline_x, line_y),
                    (radical_right, 0),
                    (trailing_space_x, 0),
                ],
                [radical_scale, 1, 1, 1],
            )
        elseif head == :text
            modifier, content = args
            new_state = add_font_modifier(state, modifier)
            new_state = change_mode(new_state, :text)
            return tex_layout(content, new_state)
        elseif head == :underover
            core, sub, super = tex_layout.(args, state)

            mid = hmid(core)
            dxsub = mid - hmid(sub) * shrink
            dxsuper = mid - hmid(super) * shrink

            under_offset = bottominkbound(core) - 0.1 - ascender(sub) * shrink
            over_offset = topinkbound(core) - descender(super)

            # The leftmost element must have x = 0
            x0 = -min(0, dxsub, dxsuper)
            y0 = 0.0

            return Group(
                [core, sub, super],
                Point2f[
                    (x0, y0),
                    (x0 + dxsub, y0 + under_offset),
                    (x0 + dxsuper, y0 + over_offset),
                ],
                [1, shrink, shrink];
                slanted = is_slanted(core),
            )
        elseif head == :unicode
            font_id, glyph_id = argument_as_string.(args)
            font_id = Symbol(font_id)
            font = get_font(state.font_family, font_id)
            glyph_id = glyph_index(font, Char(parse(Culong, glyph_id)))
            return TeXChar(glyph_id, font, state.font_family, false, '?')
        end
    catch
        # TODO Better error
        rethrow()
        @error "Error while layouting expr"
    end

    throw(ArgumentError("Unsupported head :$(head) in TeXExpr\n$expr"))
end

tex_layout(::Nothing, state) = Space(0)

"""
    horizontal_layout(elements)

Layout the elements horizontally, like normal text.
"""
function horizontal_layout(elements; italic_correction = false)
    if italic_correction
        elements = _italic_correction(elements)
    end

    dxs = hadvance.(elements)
    xs = [0, cumsum(dxs[1:(end - 1)])...]

    return Group(elements, Point2f.(xs, 0); slanted = is_slanted(last(elements)))
end

function _add_math_operator_spacing(args, elements)
    spaced = TeXElement[]

    for (i, elem) in enumerate(elements)
        push!(spaced, elem)
        if _is_spaced_math_operator(args[i]) && _operator_takes_space(args, i)
            push!(spaced, Space(1 / 6))
        end
    end

    return spaced
end

function _operator_takes_space(args, i)
    next = findnext(arg -> !(arg.head == :char && only(arg.args) == ' '), args, i + 1)
    return !isnothing(next) && !_is_opening_delimiter(args[next])
end

function _is_spaced_math_operator(arg)
    arg isa TeXExpr || return false
    arg.head == :function && return true
    return arg.head in (:decorated, :underover) && _is_spaced_math_operator(first(arg.args))
end

function _is_opening_delimiter(expr)
    return expr.head == :delimiter && only(expr.args) in ('(', '[', '⟨', '{')
end

function _italic_correction(elements)
    corrected = TeXElement[]

    for (i, elem) in enumerate(elements)
        if i > 1
            offset = italic_transition_offset(elements[i - 1], elem)
            if offset != 0
                push!(corrected, Space(offset))
            end
        end
        push!(corrected, elem)
    end

    return corrected
end

function italic_transition_offset(prev, elem)
    (prev isa Space || elem isa Space) && return 0.0

    if is_slanted(prev) && is_slanted(elem)
        return slanted_adjacent_offset(prev, elem)
    elseif !is_slanted(prev) && !is_slanted(elem)
        return 0.0
    end

    if is_slanted(prev) && !is_slanted(elem)
        height_prev = topinkbound(prev)
        height_prev <= 0 && return 0.0

        overhang = rightinkbound(prev) - hadvance(prev)
        overhang <= 0 && return 0.0

        height_elem = topinkbound(elem)
        return height_prev <= height_elem ? overhang : overhang * height_elem / height_prev
    elseif !is_slanted(prev) && is_slanted(elem)
        bearing = leftinkbound(elem)

        if bearing < 0
            depth_prev = inkheight(prev) - topinkbound(prev)
            depth_elem = inkheight(elem) - topinkbound(elem)
            depth_prev <= 0 && return 0.0
            return depth_prev >= depth_elem ? -bearing : -bearing * depth_prev / depth_elem
        end

        # Positive left bearings on italic glyphs make e.g. "(t)" look
        # asymmetric. Remove that extra font-side gap at roman-to-italic edges.
        if prev isa TeXChar
            if isdigit(prev.represented_char)
                if _is_lowercase_latin(elem)
                    gap = hadvance(prev) + bearing - rightinkbound(prev)
                    target_gap = _latin_italic_target_gap(prev, elem)
                    gap > target_gap && return target_gap - gap
                end
                return -_DIGIT_ITALIC_LEFT_BEARING_CORRECTION * bearing
            elseif _is_math_punctuation(prev.represented_char)
                return 0.0
            end
        end
        return -bearing
    end

    return 0.0
end

_is_math_punctuation(char) = char in (',', ';', '.', '!')

function slanted_adjacent_offset(prev, elem)
    top = min(topinkbound(prev), topinkbound(elem))
    bottom = max(bottominkbound(prev), bottominkbound(elem))
    top <= bottom && return 0.0

    gap = hadvance(prev) + leftinkbound(elem) - rightinkbound(prev)
    min_gap = _SLANTED_ADJACENT_GAP * min(inkheight(prev), inkheight(elem))
    if _is_lowercase_latin(prev) && _is_lowercase_latin(elem)
        target_gap = max(min_gap, _latin_italic_target_gap(prev, elem))
        gap > target_gap && return target_gap - gap
    end

    offset = min_gap - gap
    return max(0.0, min(offset, 2min_gap))
end

_is_lowercase_latin(elem) =
    elem isa TeXChar && 'a' <= elem.represented_char <= 'z'

_latin_italic_target_gap(prev, elem) =
    _LATIN_ITALIC_PAIR_GAP * min(inkheight(prev), inkheight(elem))

function layout_text(string, font_family)
    isempty(string) && return Space(0)

    elements = TeXChar.(collect(string), LayoutState(font_family), Ref(:text))
    return horizontal_layout(elements)
end

"""
    unravel(element::TeXElement, pos, scale)

Flatten the layouted TeXElement and produce a single list of base element with
their associated absolute position and scale.
"""
function unravel(group::Group, parent_pos = Point2f(0), parent_scale = 1.0f0)
    scales = group.scales .* parent_scale
    positions = [parent_pos .+ pos for pos in parent_scale .* group.positions]
    elements = []

    for (elem, pos, scale) in zip(group.elements, positions, scales)
        push!(elements, unravel(elem, pos, scale)...)
    end

    return elements
end

unravel(::Space, pos, scale) = []
unravel(element, pos, scale) = [(element, pos, scale)]

"""
    generate_tex_elements(str)

Create a list of tuple `(texelement, position, scale)` from a string
of LaTeX math mode code. The elements' positions and scales are such as to
approximatively reproduce the LaTeX output.

The elments are of one of the following types

    - `TeXChar` a (unicode) character with a specific font.
    - `HLine` a horizontal line.
    - `VLine` a vertical line.
"""
function generate_tex_elements(str, font_family = FontFamily())
    expr = texparse(str)

    for node in PreOrderDFS(expr)
        if node isa TeXExpr && node.head == :fontfamily
            # Reconstruct the argument as a single string
            name = join([texchar.args[1] for texchar in node.args[1].args])
            font_family = FontFamily(name)
            break
        end
    end
    layout = tex_layout(expr, font_family)
    return unravel(layout)
end

function test_same_layout(layout1, layout2)
    @test all(layout1.positions .== layout2.positions)
    @test all(layout1.scales .== layout2.scales)

    for (elem1, elem2) in zip(layout1.elements, layout2.elements)
        if elem1 isa TeXElement
            @test elem1 == elem2
        else
            test_same_layout(elem1, elem2)
        end
    end
    return
end

ink_bottom(element) = element[2][2] + element[3] * bottominkbound(element[1])
ink_left(element) = element[2][1] + element[3] * leftinkbound(element[1])
ink_right(element) = element[2][1] + element[3] * rightinkbound(element[1])
ink_top(element) = element[2][2] + element[3] * topinkbound(element[1])
ink_vmid(element) = (ink_bottom(element) + ink_top(element)) / 2
ink_group_vmid(elements) = (minimum(ink_bottom, elements) + maximum(ink_top, elements)) / 2

@testset "Layout" begin
    @testset "Group ink bounds" begin
        @test rightinkbound(Space(1.2)) == 1.2

        trailing_space_layout = tex_layout(texparse(raw"x\;"), FontFamily())
        @test rightinkbound(trailing_space_layout) < hadvance(trailing_space_layout)
        @test rightinkbound(trailing_space_layout) ≈ rightinkbound(trailing_space_layout.elements[1])

        internal_space_layout = tex_layout(texparse(raw"x\;y"), FontFamily())
        @test rightinkbound(internal_space_layout) >
            internal_space_layout.positions[2][1] + rightinkbound(internal_space_layout.elements[2])

        digit = tex_layout(manual_texexpr((:digit, '2')), FontFamily())
        @test MathTeXEngine.ascender(digit) > topinkbound(digit)
    end

    @testset "Decorated" begin
        expr = manual_texexpr((:decorated, 'x', 'b', 't'))
        layout = tex_layout(expr, FontFamily())
        @test length(layout.elements) == 3
        @test layout.positions[2][2] < layout.positions[3][2]
        @test layout.scales[1] == 1
        @test layout.scales[2] < 1
        @test layout.scales[3] < 1

        expr = manual_texexpr((:decorated, 'y', nothing, 't'))
        layout = tex_layout(expr, FontFamily())
        @test layout.elements[2] == Space(0)

        expr = manual_texexpr((:decorated, 'z', 'b', nothing))
        layout = tex_layout(expr, FontFamily())
        @test layout.elements[3] == Space(0)

        @test length(generate_tex_elements(L"a_b^c")) == 3
        @test length(generate_tex_elements(L"_b^c")) == 2

        elems = generate_tex_elements(L"\left(\frac{dy}{dx}\right)_0")
        @test ink_bottom(elems[8]) < ink_bottom(elems[7]) - 0.03
        @test ink_top(elems[8]) > ink_bottom(elems[7])

        elems = generate_tex_elements(L"\left(\frac{A^{xy}}{B}\right)^{1/4}")
        @test ink_top(elems[8]) > ink_top(elems[7]) + 0.03
        @test ink_bottom(elems[8]) < ink_top(elems[7])

        @test generate_tex_elements(L"W^{(i+j)}")[2][3] ≈ 0.6
        @test generate_tex_elements(L"x_{y \rightarrow 0}")[2][3] ≈ 0.6

        ordinary_elems = generate_tex_elements(L"V^1_2")
        sub_start = ordinary_elems[2][2][1] +
            ordinary_elems[2][3] * leftinkbound(ordinary_elems[2][1])
        super_start = ordinary_elems[3][2][1] +
            ordinary_elems[3][3] * leftinkbound(ordinary_elems[3][1])
        @test sub_start < super_start

        star_elems = generate_tex_elements(L"x^*")
        @test ink_top(star_elems[2]) > ink_top(star_elems[1])
        @test ink_bottom(star_elems[2]) < xheight(FontFamily()) + 0.05
    end

    @testset "Delimited" begin
        expr = manual_texexpr((:delimited, '(', L"\sum_a^b", ')'))
        layout = tex_layout(expr, FontFamily())

        hs = inkheight.(layout.elements) .* layout.scales
        @test hs[1] >= hs[2]
        @test hs[3] >= hs[2]

        simple_elems = generate_tex_elements(L"\left(1 + 2\right)")
        simple_axis = ink_group_vmid(simple_elems[[2, 4]])
        @test ink_vmid(simple_elems[1]) ≈ simple_axis atol = 0.01
        @test ink_vmid(simple_elems[end]) ≈ simple_axis atol = 0.01

        capital_elems = generate_tex_elements(L"\left{A + B\right}")
        capital_axis = ink_group_vmid(capital_elems[[2, 4]])
        @test ink_vmid(capital_elems[1]) ≈ capital_axis atol = 0.01
        @test ink_vmid(capital_elems[end]) ≈ capital_axis atol = 0.01

        fraction_elems = generate_tex_elements(L"\left(\frac{1}{2}\right)")
        fraction_axis = max(ink_group_vmid(fraction_elems[2:(end - 1)]), xheight(FontFamily()) / 2)
        @test ink_vmid(fraction_elems[1]) ≈ fraction_axis atol = 0.01
        @test ink_vmid(fraction_elems[end]) ≈ fraction_axis atol = 0.01

        descender_fraction_elems = generate_tex_elements(L"\left[\frac{a}{b}\right]")
        @test ink_bottom(descender_fraction_elems[1]) <= ink_bottom(descender_fraction_elems[end - 1])
        @test ink_top(descender_fraction_elems[1]) >= ink_top(descender_fraction_elems[2])

        greek_brace_fraction_elems = generate_tex_elements(L"\left{\frac{\alpha}{\beta}\right}")
        @test greek_brace_fraction_elems[1][3] < descender_fraction_elems[1][3]

        nested_elems = generate_tex_elements(L"\left{1 + \left[2 + \left(3 + 4\right)\right]\right}")
        nested_axis = ink_group_vmid(nested_elems[[2, 5, 8, 10]])
        nested_delimiters = nested_elems[[1, 4, 7, 11, 12, 13]]
        @test maximum(abs(ink_vmid(elem) - nested_axis) for elem in nested_delimiters) < 0.015

        elems = generate_tex_elements(
            L"\left\langle\left|\left\langle\left|\int\right|\right\rangle\right|\right\rangle",
        )
        @test maximum(abs(ink_vmid(elem) - ink_vmid(elems[5])) for elem in elems) < 0.1

        for font_name in keys(MathTeXEngine.default_font_families)
            bar = tex_layout(manual_texexpr((:delimiter, '|')), MathTeXEngine.FontFamily(font_name))
            default_bar_id, _ = MathTeXEngine.default_math_glyph('|')
            @test bar.glyph_id == default_bar_id

            paren = tex_layout(manual_texexpr((:delimiter, '(')), MathTeXEngine.FontFamily(font_name))
            default_paren_id, _ = MathTeXEngine.default_math_glyph('(')
            @test paren.glyph_id == default_paren_id
        end
    end

    @testset "Font" begin
        expr = manual_texexpr((:char, 'u'))
        texchar = tex_layout(expr, FontFamily())
        @test isa(texchar, TeXChar)

        expr = manual_texexpr((:font, :rm, 'u'))
        texchar = tex_layout(expr, FontFamily())
        @test isa(texchar, TeXChar)
    end

    @testset "Group" begin
        expr = manual_texexpr((:group, 'a', 'b', 'c'))
        layout = tex_layout(expr, FontFamily())
        @test length(layout.elements) == 3
        @test length(layout.positions) == 3
        @test length(layout.scales) == 3
        @test all([pos[2] == 0 for pos in layout.positions])
        @test all(layout.scales .== 1)

        expr = manual_texexpr((:group, 'x', (:group, 'y')))
        layout = tex_layout(expr, FontFamily())
        subexpr = manual_texexpr((:group, 'y'))
        sublayout = tex_layout(subexpr, FontFamily())
        @test length(layout.elements) == 2
        @test length(layout.positions) == 2
        @test length(layout.scales) == 2
        test_same_layout(sublayout, layout.elements[2])

        @test isempty(generate_tex_elements(L"{}"))
        @test isempty(generate_tex_elements(L""))
    end

    @testset "Space" begin
        elems = generate_tex_elements(L"\quad a")
        @test length(elems) == 1
        char, pos, size = first(elems)
        @test pos[1] == 1

        elems = generate_tex_elements(L"\qquad b")
        @test length(elems) == 1
        char, pos, size = first(elems)
        @test pos[1] == 2
    end

    @testset "Italic boundary correction" begin
        old = MathTeXEngine.italic_correction_enabled[]
        try
            MathTeXEngine.italic_correction_enabled[] = false
            without = generate_tex_elements(L"(f)x η(t)")

            MathTeXEngine.italic_correction_enabled[] = true
            with = generate_tex_elements(L"(f)x η(t)")

            xpos(elems, i) = elems[i][2][1]

            # Issue #142: roman delimiters next to italic glyphs should not
            # inherit an asymmetric font-side gap.
            @test xpos(with, 2) > xpos(without, 2)
            @test xpos(with, 3) > xpos(without, 3)

            # Issue #95: the same boundary correction also applies to lower
            # case Greek followed by roman delimiters in subscripts/labels.
            @test MathTeXEngine.is_slanted(with[5][1])
            @test xpos(with, 7) - xpos(with, 6) < xpos(without, 7) - xpos(without, 6)
            @test xpos(with, 8) - xpos(with, 7) > xpos(without, 8) - xpos(without, 7)

            MathTeXEngine.italic_correction_enabled[] = false
            without = generate_tex_elements(L"k\xi")
            MathTeXEngine.italic_correction_enabled[] = true
            with = generate_tex_elements(L"k\xi")

            # Adjacent slanted glyphs can still collide even without a
            # roman/italic transition. Keep a small ink gap for cases like kξ.
            @test ink_left(with[2]) - ink_right(with[1]) >
                ink_left(without[2]) - ink_right(without[1])
            @test ink_left(with[2]) - ink_right(with[1]) > 0.01

            MathTeXEngine.italic_correction_enabled[] = false
            without = generate_tex_elements(L"ab")
            MathTeXEngine.italic_correction_enabled[] = true
            with = generate_tex_elements(L"ab")

            # Adjacent Latin italic variables should be compact like TeX math,
            # while the Greek collision case above still keeps a safe gap.
            @test ink_left(with[2]) - ink_right(with[1]) <
                ink_left(without[2]) - ink_right(without[1])
            @test 0.02 < ink_left(with[2]) - ink_right(with[1]) < 0.06

            MathTeXEngine.italic_correction_enabled[] = false
            without = generate_tex_elements(L"2ab")
            MathTeXEngine.italic_correction_enabled[] = true
            with = generate_tex_elements(L"2ab")

            # Digit-letter juxtaposition represents implicit multiplication,
            # not a delimiter boundary. Tuck the italic left bearing only
            # partway so 2a resembles the natural ab spacing without cramping.
            digit_gap_without = ink_left(without[2]) - ink_right(without[1])
            digit_gap_with = ink_left(with[2]) - ink_right(with[1])
            letter_gap_with = ink_left(with[3]) - ink_right(with[2])
            @test 0 < digit_gap_with < digit_gap_without
            @test digit_gap_with ≈ letter_gap_with atol = 0.02
            @test digit_gap_with < 0.06

            MathTeXEngine.italic_correction_enabled[] = false
            without = generate_tex_elements(L"W(\alpha,\alpha^*)")
            MathTeXEngine.italic_correction_enabled[] = true
            with = generate_tex_elements(L"W(\alpha,\alpha^*)")

            # Punctuation in multi-argument labels should keep the natural
            # breathing room before the next italic/Greek argument.
            @test ink_left(with[5]) - ink_right(with[4]) ≈
                ink_left(without[5]) - ink_right(without[4]) atol = 1.0e-6
        finally
            MathTeXEngine.italic_correction_enabled[] = old
        end
    end

    @testset "Function spacing" begin
        xpos(elems, i) = elems[i][2][1]
        inline_layout(expr) = tex_layout(texparse(expr), FontFamily()).elements[1]

        # Issue #129: LaTeX inserts a thin space after math operators when
        # the argument is not parenthesized.
        @test xpos(generate_tex_elements(L"\log x"), 4) >
            xpos(generate_tex_elements(L"\mathrm{log}x"), 4) + 0.1
        @test xpos(generate_tex_elements(L"\sin\alpha"), 4) >
            xpos(generate_tex_elements(L"\mathrm{sin}\alpha"), 4) + 0.1
        @test inline_layout(L"\inf_x\tan(x)").elements[2] == Space(1 / 6)
        @test inline_layout(L"\sup_x\tan(x)").elements[2] == Space(1 / 6)

        # No operator space is inserted before an opening delimiter.
        @test xpos(generate_tex_elements(L"\log(x)"), 4) ≈
            xpos(generate_tex_elements(L"\mathrm{log}(x)"), 4)
        @test !(inline_layout(L"\inf_x(\tan(x))").elements[2] isa Space)

        gtrsim = generate_tex_elements(L"U\gtrsim\mu")
        unicode_gtrsim = generate_tex_elements(L"U≳\mu")
        @test ink_left(gtrsim[2]) - ink_right(gtrsim[1]) > 0.15
        @test ink_left(gtrsim[3]) - ink_right(gtrsim[2]) > 0.15
        @test ink_left(unicode_gtrsim[2]) - ink_right(unicode_gtrsim[1]) ≈
            ink_left(gtrsim[2]) - ink_right(gtrsim[1])
    end

    @testset "Fraction rule padding" begin
        elems = generate_tex_elements(L"\frac{1}{2}")
        rule_start = elems[1][2][1] + elems[1][3] * leftinkbound(elems[1][1])
        rule_end = elems[1][2][1] + elems[1][3] * rightinkbound(elems[1][1])
        numerator_start = elems[2][2][1] + elems[2][3] * leftinkbound(elems[2][1])
        denominator_end = elems[3][2][1] + elems[3][3] * rightinkbound(elems[3][1])
        @test numerator_start - rule_start > 0.1
        @test rule_end - denominator_end > 0.1
        @test abs((numerator_start - rule_start) - (rule_end - denominator_end)) < 0.05

        elems = generate_tex_elements(L"x^{\frac{1}{1+2}}")
        rule_end = elems[2][2][1] + elems[2][3] * rightinkbound(elems[2][1])
        denom_end = maximum(e[2][1] + e[3] * rightinkbound(e[1]) for e in elems[4:6])
        @test rule_end - denom_end < 0.1
    end

    @testset "Square root glyph fallback" begin
        for font_name in keys(MathTeXEngine.default_font_families)
            elems = generate_tex_elements(L"\sqrt{3}", MathTeXEngine.FontFamily(font_name))
            @test elems[1][1] isa TeXChar
            @test elems[1][1].represented_char == '√'
            @test elems[1][1].glyph_id != 0
            @test elems[1][3] * inkheight(elems[1][1]) <= 1.25
            @test ink_top(elems[2]) ≈ ink_top(elems[1]) atol = 1.0e-6
            @test minimum(ink_bottom, elems[3:end]) - ink_bottom(elems[1]) < 0.35

            sqrt_x_elems = generate_tex_elements(L"\sqrt{x}", MathTeXEngine.FontFamily(font_name))
            @test minimum(ink_bottom, sqrt_x_elems[3:end]) - ink_bottom(sqrt_x_elems[1]) <=
                0.45 * xheight(MathTeXEngine.FontFamily(font_name)) + 1.0e-6

            empty_elems = generate_tex_elements(L"\sqrt{}", MathTeXEngine.FontFamily(font_name))
            @test empty_elems[1][1].represented_char == '√'
            @test empty_elems[1][1].glyph_id != 0
            @test rightinkbound(empty_elems[2][1]) > 0

            tall_elems = generate_tex_elements(
                L"\sqrt{x_i^2+y_i^2}",
                MathTeXEngine.FontFamily(font_name),
            )
            @test ink_bottom(tall_elems[2]) >= maximum(ink_top(e) for e in tall_elems[3:end])
        end

        frac_elems = generate_tex_elements(L"\sqrt{\frac{1}{2}}")
        simple_root = generate_tex_elements(L"\sqrt{x}")[1]
        @test frac_elems[1][1].glyph_id != simple_root[1].glyph_id
        @test ink_bottom(frac_elems[2]) - maximum(ink_top(e) for e in frac_elems[3:end]) >
            xheight(MathTeXEngine.FontFamily()) / 3
        @test ink_bottom(frac_elems[2]) - maximum(ink_top(e) for e in frac_elems[3:end]) <
            0.55 * xheight(MathTeXEngine.FontFamily())
        @test minimum(ink_bottom(e) for e in frac_elems[3:end]) - ink_bottom(frac_elems[1]) <
            xheight(MathTeXEngine.FontFamily())
        @test ink_right(frac_elems[2]) - maximum(ink_right(e) for e in frac_elems[3:end]) <
            0.1

        sqrt_layout = tex_layout(texparse(raw"\sqrt{\frac{1}{2}}"), FontFamily()).elements[1]
        @test rightinkbound(sqrt_layout) < hadvance(sqrt_layout)
        @test sqrt_layout.positions[2][1] + rightinkbound(sqrt_layout.elements[2]) ≈
            rightinkbound(sqrt_layout)

        followed_sqrt_layout = tex_layout(texparse(raw"\sqrt{\frac{1}{2}}\sin(x)"), FontFamily())
        @test followed_sqrt_layout.positions[2][1] ≈ hadvance(sqrt_layout)

        simple_sqrt_layout = tex_layout(texparse(raw"\sqrt{2}"), FontFamily()).elements[1]
        @test MathTeXEngine.ascender(simple_sqrt_layout) ≈ topinkbound(simple_sqrt_layout)
        simple_sqrt_glyph = generate_tex_elements(L"\sqrt{2}")[1][1]
        @test MathTeXEngine.ascender(simple_sqrt_glyph) ≈ topinkbound(simple_sqrt_glyph)

        ylabel_layout = tex_layout(
            texparse(L"x + y - \sin(x) × \tan(y) + \sqrt{2}"),
            FontFamily(),
        ).elements[1]
        @test MathTeXEngine.ascender(ylabel_layout) ≈ topinkbound(ylabel_layout)

        wide_frac_elems = generate_tex_elements(L"\sqrt{\frac{1+6}{4+a+g}}")
        @test ink_bottom(wide_frac_elems[2]) - maximum(ink_top(e) for e in wide_frac_elems[3:end]) >
            0.4 * xheight(MathTeXEngine.FontFamily())

        simple_elems = generate_tex_elements(L"\sqrt{b^2 - 4ac}")
        @test simple_elems[1][1].glyph_id != simple_root[1].glyph_id
        @test ink_bottom(simple_elems[1]) > -0.4
    end

    @testset "Missing math symbols use default math fallback" begin
        for font_name in keys(MathTeXEngine.default_font_families)
            elems = generate_tex_elements(L"\int_0^1 f(x) dx", MathTeXEngine.FontFamily(font_name))
            @test elems[1][1] isa TeXChar
            @test elems[1][1].represented_char == '∫'
            @test elems[1][1].glyph_id != 0
        end

        elems = generate_tex_elements(L"\int", MathTeXEngine.FontFamily("NewComputerModern"))
        @test inkheight(elems[1][1]) > 2.0

        nested_elems = generate_tex_elements(
            L"\left\langle\left|\int\right|\right\rangle",
            MathTeXEngine.FontFamily("NewComputerModern"),
        )
        @test all(e -> e[1].glyph_id != 0, nested_elems)
        @test nested_elems[3][3] == 1
        @test nested_elems[1][3] < 1.5
        @test abs(ink_vmid(nested_elems[1]) - ink_vmid(nested_elems[3])) < 0.05
        @test abs(ink_vmid(nested_elems[2]) - ink_vmid(nested_elems[3])) < 0.05
    end

    @testset "Subscript spacing respects italic overhangs" begin
        ink_start(element) = element[2][1] + element[3] * leftinkbound(element[1])
        ink_end(element) = element[2][1] + element[3] * rightinkbound(element[1])

        font_names = sort(collect(keys(MathTeXEngine.default_font_families)))
        for font_name in font_names
            elems = generate_tex_elements(L"x_{\alpha(k)}", MathTeXEngine.FontFamily(font_name))
            @test ink_end(elems[1]) - ink_start(elems[2]) < 0.04
        end

        for font_name in font_names, tex in (L"N_\nu", L"J_\nu", L"V_\nu")
            elems = generate_tex_elements(tex, MathTeXEngine.FontFamily(font_name))
            @test elems[2][2][1] ≈ hadvance(elems[1][1])
            @test ink_start(elems[2]) < ink_end(elems[1])
        end

        for tex in (L"\mathrm{N}_\nu", L"\mathrm{J}_\nu")
            elems = generate_tex_elements(tex)
            @test ink_start(elems[2]) + 0.002 >= ink_end(elems[1])
        end

        elems = generate_tex_elements(L"N_\nu L_\nu A_\nu J_\nu")
        @test ink_start(elems[2]) < ink_end(elems[1])
        @test ink_start(elems[8]) < ink_end(elems[7])

        # Issue #95 includes a nested subscript case where the inner `(k)`
        # should stay inside the lower script instead of being squeezed left.
        for font_name in font_names
            elems = generate_tex_elements(
                L"v_{(a + b)_k}^i",
                MathTeXEngine.FontFamily(font_name),
            )
            @test ink_start(elems[7]) + 0.002 >= ink_end(elems[6])
        end
    end
end

@testset "Generate elements" begin
    elems = generate_tex_elements(L"a + b")
    @test length(elems) == 3

    elems = generate_tex_elements(L"{{a + b} - {c * d}}")
    @test length(elems) == 7

    # Check the following does not error
    tex =
        L"\lim_{α →\infty} A^j v_{(a + b)_k}^i \sqrt{2} x!= \sqrt{\frac{1+2}{4+a+x}}\int_{0}^{2π} \sin(x) dx"
    generate_tex_elements(tex)

    tex = L"Momentum $p_x$ (a.u.)"
    generate_tex_elements(tex)

    tex = L"Average $\overline{an}_i$"
    @test length(generate_tex_elements(tex)) == 12

    elems = generate_tex_elements(L"Time $t_0$")
    @test length(elems) == 7
end

using CairoMakie
using MathTeXEngine
using LaTeXStrings

include("data/basics.jl")
include("data/spacing.jl")

with_font(font_name, expr) = latexstring("\\fontfamily{$font_name}$expr")

const REFERENCES = Dict(
    "basics" => BASICS,
    "spacing" => SPACING
)

const SUPPORTED_FONTS = [
    "NewComputerModern",
    "TeXGyreHeros",
    "TeXGyrePagella",
    "LucioleMath"
]

function generate(destination_folder, references = REFERENCES, fonts = SUPPORTED_FONTS)
    @info "Generating images in folder $destination_folder"

    path = mkpath(destination_folder)
    failures = Dict()
    for (group, data) in references
        if data isa AbstractDict
            generate(joinpath(destination_folder, group), data)
        else
            fig, fails = reference_figure(data, fonts)

            if !isempty(fails)
                failures[group] = fails
            end

            save(joinpath(path, "$group.png"), fig, px_per_unit=3)
        end
    end

    return failures
end

function reference_figure(exprs, fonts = SUPPORTED_FONTS)
    fig = Figure()
    failures = Dict()
    for (j, font) in enumerate(fonts)
        Label(fig[0, j], font)
        for (i, expr) in enumerate(exprs)
            try
                Label(fig[i, j], with_font(font, expr))
            catch e
                failures[expr] = e
            end 
        end
    end
    resize_to_layout!(fig)
    return fig, failures
end

function test_parse(input, args... ; broken=false)
    arg = (:line, args...)
    if broken
        @test_broken texparse(input) == manual_texexpr(arg)
    else
        @test texparse(input) == manual_texexpr(arg)
    end
end

@testset "Parser" begin
    @testset "Accent" begin
        # First char is the combining accent
        test_parse(
            raw"\dot{a}",
            (:combining_accent, '̇', 'a')
        )
        test_parse(
            raw"\vec{x}",
            (:combining_accent, '⃗', 'x')
        )
    end

    @testset "Showing errors" begin
        @test_throws "tokenized as" texparse("{")
    end

    @testset "Delimiter" begin
        expr = texparse(L"\left(\frac{x}{y}\right)")
        delimited = expr.args[1].args[1]
        @test delimited.args[1].head == :delimiter
        @test delimited.args[2].head == :frac
        @test delimited.args[3].head == :delimiter

        test_parse(
            raw"\left(x\right)",
            (:delimited, '(', 'x', ')')
        )

        test_parse(
            raw"\left[y\right)",
            (:delimited, '[', 'y', ')')
        )

        test_parse(
            raw"\left(a+b\right)",
            (:delimited,
                '(',
                (:group, 'a', (:spaced, '+'), 'b'),
                ')'
            )
        )

        test_parse(raw"\{", (:delimiter, '{'))
        test_parse(raw"\}", (:delimiter, '}'))

        @test_throws TeXParseError texparse(raw"\left( x")
        @test_throws TeXParseError texparse(raw"x \right)")

        ## all `delimiter_symbols`
        test_parse(raw"|", (:delimiter, '|'))
        test_parse(raw"/", (:delimiter, '/'))
        test_parse(raw"\\", (:delimiter, '\\'))
        test_parse(raw"(", (:delimiter, '('))
        test_parse(raw")", (:delimiter, ')'))
        test_parse(raw"[", (:delimiter, '['))
        test_parse(raw"]", (:delimiter, ']'))
        test_parse(raw"⟨", (:delimiter, '⟨'))
        test_parse(raw"⟩", (:delimiter, '⟩'))
        test_parse(raw"‖", (:delimiter, '‖'))
        test_parse(raw"⌈", (:delimiter, '⌈'))
        test_parse(raw"⌉", (:delimiter, '⌉'))
        test_parse(raw"⌊", (:delimiter, '⌊'))
        test_parse(raw"⌋", (:delimiter, '⌋'))
        test_parse(raw"⌜", (:delimiter, '⌜'))
        test_parse(raw"⌝", (:delimiter, '⌝'))
        test_parse(raw"⌞", (:delimiter, '⌞'))
        test_parse(raw"⌟", (:delimiter, '⌟'))

        test_parse(raw"<", (:space, '<'))   # formerly, this was a delimiter
        test_parse(raw">", (:space, '>'))

        ## all `delimiter_commands`
        test_parse(raw"\vert", (:delimiter, '|'))
        test_parse(raw"\slash", (:delimiter, '/'))
        test_parse(raw"\backslash", (:delimiter, '\\'))
        test_parse(raw"\lbrack", (:delimiter, '['))
        test_parse(raw"\rbrack", (:delimiter, ']'))
        test_parse(raw"\langle", (:delimiter, '⟨'))
        test_parse(raw"\rangle", (:delimiter, '⟩'))
        test_parse(raw"\|", (:delimiter, '‖'))
        test_parse(raw"\Vert", (:delimiter, '‖'))
        test_parse(raw"\lceil", (:delimiter, '⌈'))
        test_parse(raw"\rceil", (:delimiter, '⌉'))
        test_parse(raw"\lfloor", (:delimiter, '⌊'))
        test_parse(raw"\lfloor", (:delimiter, '⌊'))
        test_parse(raw"\ulcorner", (:delimiter, '⌜'))
        test_parse(raw"\urcorner", (:delimiter, '⌝'))
        test_parse(raw"\llcorner", (:delimiter, '⌞'))
        test_parse(raw"\lrcorner", (:delimiter, '⌟'))
        test_parse(raw"\{", (:delimiter, '{'))
        test_parse(raw"\}", (:delimiter, '}'))
        test_parse(raw"\lbrace", (:delimiter, '{'))
        test_parse(raw"\rbrace", (:delimiter, '}'))
     
        ### test commands as arguments to a delimited group
        for (cmd_str, delim_symb) in pairs(MathTeXEngine.delimiter_commands)
            ## NOTE this does not check for "correct" left right pairs like `\lbrack` and `\rbrack`
            test_parse(
                "\\left$(cmd_str)\\right$(cmd_str)", 
                (:delimited,
                    (:delimiter, delim_symb),
                    (:group,),
                    (:delimiter, delim_symb)
                )
            )
        end
    end

    @testset "Fonts" begin
        test_parse(raw"\mathrm{u}", (:font, :rm, (:char, 'u')))
        test_parse(raw"\text{u}", (:text, :rm, (:char, 'u')))

        test_parse(raw"\mathrm{u v}", (:text, :rm,
            (:group,
                (:char, 'u'),
                (:char, ' '),
                (:char, 'v')
            )))
        test_parse(raw"\text{u v}", (:text, :rm,
            (:group,
                (:char, 'u'),
                (:char, ' '),
                (:char, 'v')
            )))

        @test texparse(raw"ℝ") == texparse(raw"\mathbb{R}")
    end

    @testset "Fraction" begin
        test_parse(raw"\frac{1}{n}", (:frac, (:digit, '1'), 'n'))
    end

    @testset "Function" begin
        # Check that braces are not added to the function name
        test_parse(raw"\sin{x}", (:function, "sin"), 'x')
        test_parse(
            raw"\exp(x)",
            (:function, "exp"), '(', 'x', ')'
        )
        test_parse(
            raw"\tan\alpha",
            (:function, "tan"), (:symbol, 'α')
        )
    end

    @testset "Group" begin
        test_parse(raw"{x}", 'x')
        test_parse(raw"{fgh}", (:group, 'f', 'g', 'h'))
        test_parse(
            raw"{a{b{cd}}}",
            (:group, 'a', (:group, 'b', (:group, 'c', 'd')))
        )
        test_parse(raw"{}", (:space, 0.0))

        @test_throws TeXParseError texparse(raw"{v")
        @test_throws TeXParseError texparse(raw"w}")
    end

    @testset "Integral" begin
        test_parse(
            raw"\int",
            (:integral, (:symbol, '∫'), nothing, nothing)
        )
        test_parse(
            raw"\int_a^b",
            (:integral, (:symbol, '∫'), 'a', 'b')
        )
    end

    @testset "Linebreak" begin
        expr = texparse(L"$A$\\$B$\\$C$")
        @test expr.head == :lines
        @test length(expr.args) == 3
    end

    @testset "LaTeXString input" begin
        @test texparse(raw"$\gamma$") == texparse(L"\gamma")
    end

    @testset "Overunder" begin
        test_parse(
            raw"\sum",
            (:underover, (:symbol, '∑'), nothing, nothing)
        )
        test_parse(
            raw"\sum_{k=0}^n",
            (:underover,
                (:symbol, '∑'),
                (:group, 'k', (:spaced, (:symbol, '=')), (:digit, '0')),
                'n'
            )
        )
        test_parse(
            raw"\lim_x",
            (:underover,
                (:function, "lim"),
                'x',
                nothing
            )
        )
    end

    @testset "Square root" begin
        test_parse(raw"\sqrt{x}", (:sqrt, 'x'))
        test_parse(
            raw"\sqrt{abc}",
            (:sqrt, (:group, 'a', 'b', 'c'))
        )
    end

    @testset "Overline" begin
        test_parse(raw"\overline{x}", (:overline, 'x'))
        test_parse(
            raw"\overline{abc}",
            (:overline, (:group, 'a', 'b', 'c'))
        )
    end

    @testset "Space" begin
        test_parse(raw"\quad", (:space, 1))
        test_parse(raw"\qquad", (:space, 2))
        test_parse(raw"~", (:space, 0.33333))
    end

    @testset "Spaced symbol" begin
        test_parse(raw"=", (:spaced, (:symbol, '=')))
        test_parse(
            raw"\rightarrow",
            (:spaced, (:symbol, '→'))
        )
        # Hyphen must be replaced by a minus sign
        test_parse(raw"-", (:spaced, (:symbol, '−')))

        test_parse(raw"a-b $c-d$",
                   (:char, 'a'), (:char, '-'), (:char, 'b'),
                   (:char, ' '),
                   (:inline_math,
                    (:char, 'c'),
                    (:spaced, (:symbol, '−')),
                    (:char, 'd')))
    end

    @testset "Unary operator spacing heuristic" begin
        old = MathTeXEngine.unspace_binary_operators_heuristic_enabled[]
        try
            MathTeXEngine.unspace_binary_operators_heuristic_enabled[] = true

            test_parse(raw"$-1$", (:inline_math, (:symbol, '−'), (:digit, '1')))
            test_parse(raw"$2-1$",
                       (:inline_math,
                        (:digit, '2'),
                        (:spaced, (:symbol, '−')),
                        (:digit, '1')))
            test_parse(raw"$\alpha^*$",
                       (:inline_math,
                        (:decorated, (:symbol, 'α'), nothing, (:symbol, '*'))))
            test_parse(raw"$\frac{1}{2}\pm\sqrt{3}$",
                       (:inline_math,
                        (:frac, (:digit, '1'), (:digit, '2')),
                        (:spaced, (:symbol, '±')),
                        (:sqrt, (:digit, '3'))))
            test_parse(raw"$\frac{1}{2}{}\pm\sqrt{3}$",
                       (:inline_math,
                        (:frac, (:digit, '1'), (:digit, '2')),
                        (:space, 0.0),
                        (:symbol, '±'),
                        (:sqrt, (:digit, '3'))))

            MathTeXEngine.unspace_binary_operators_heuristic_enabled[] = false
            test_parse(raw"$-1$", (:inline_math, (:spaced, (:symbol, '−')), (:digit, '1')))
            test_parse(raw"$\alpha^*$",
                       (:inline_math,
                        (:decorated, (:symbol, 'α'), nothing, (:spaced, (:symbol, '*')))))
        finally
            MathTeXEngine.unspace_binary_operators_heuristic_enabled[] = old
        end
    end

    @testset "Subscript and superscript" begin
        @test texparse(raw"a^2_3") == texparse(raw"a_3^2")
        @test texparse(raw"^7_b") == texparse(raw"{}^7_b")
    end

    @testset "Symbol" begin
        test_symbols = [
            ("ϕ", raw"\phi"),
            ("φ", raw"\varphi"),
            ("Φ", raw"\Phi"),
            # The following test symbols with multiple commands
            ("ε", raw"\varepsilon"),
            ("ε", raw"\upepsilon")
        ]

        for (char, sym) in test_symbols
            test_parse(sym, (:symbol, first(char)))
            @test texparse(char) == texparse(sym)
        end

        # Check interaction with decoration
        test_parse(
            raw"ω_k",
            (:decorated, (:symbol, 'ω'), 'k', nothing)
        )
    end
end

tex_tokens = [
    :char => re".",
    :primes => re"'+",
    :caret => re"\^",
    :underscore => re"_",
    :rcurly => re"}",
    :lcurly => re"{",
    :command => re"\\[a-zA-Z]+" | re"\\.",
    :right => re"\\right.",
    :left => re"\\left.",
    :newline => (re"\\" * re"\\") | re"\\n",
    :dollar => re"$"
]

@eval @enum TeXToken error $(first.(tex_tokens)...)
make_tokenizer((error, 
    [TeXToken(i) => j for (i, j) in enumerate(last.(tex_tokens))]
)) |> eval

struct LayoutState
    font_family::FontFamily
    font_modifiers::Vector{Symbol}
    tex_mode::Symbol
end

LayoutState(font_family::FontFamily, modifiers::Vector) = LayoutState(font_family, modifiers, :text)
LayoutState(font_family::FontFamily) = LayoutState(font_family, Symbol[])
LayoutState() = LayoutState(FontFamily())

function Base.show(io::IO, state::LayoutState)
    print(io, "LayoutState($(state.font_modifiers), $(state.tex_mode))")
end

Base.broadcastable(state::LayoutState) = Ref(state)

function change_mode(state::LayoutState, mode)
    LayoutState(state.font_family, state.font_modifiers, mode)
end

function add_font_modifier(state::LayoutState, modifier)
    modifiers = vcat(state.font_modifiers, modifier)
    return LayoutState(state.font_family, modifiers, state.tex_mode)
end

function get_font(state::LayoutState, char_type)
    if state.tex_mode == :text
        char_type = :text
    end

    font_family = state.font_family
    font_id = font_family.font_mapping[char_type]

    for modifier in state.font_modifiers
        if haskey(font_family.font_modifiers, modifier)
            mapping = font_family.font_modifiers[modifier]
            font_id = get(mapping, font_id, font_id)
        else
            throw(ArgumentError("font modifier $modifier not supported for the current font family."))
        end
    end

    return get_font(font_family, font_id)
end

@testset "TeXExpr" begin
    @testset "leafmap" begin
        ab = texparse(raw"a + b_a")
        xx = texparse(raw"x + b_x")

        @test xx == MathTeXEngine.leafmap(ab) do leaf
            leaf.args[1] == 'a' && return TeXExpr(:char, 'x')
            return leaf
        end
    end
end

const SPACING = Dict(
    "Issue #142 italic roman boundaries" => [
        raw"f(t)",
        raw"g(x)",
        raw"(f)x",
        raw"(t)",
        raw"\eta(t)",
        raw"\alpha(t)",
        raw"W(\alpha,\alpha^*)",
        raw"g(f(x))",
        raw"\mathrm{y}(x)",
        raw"\mathrm{g}t",
    ],
    "Issue #95 lower-case Greek and subscript spacing" => [
        raw"\eta(t)",
        raw"\alpha_k",
        raw"\omega_k",
        raw"k\xi",
        raw"\nu(k)",
        raw"N_\nu L_\nu A_\nu J_\nu",
        raw"x_{\alpha(k)}",
        raw"v_{(a + b)_k}^i",
        raw"\partial_i u_j",
        raw"\phi_\varphi \rho_\sigma",
    ],
    "Subscript and superscript combinations" => [
        raw"x_i",
        raw"x^i",
        raw"x_i^j",
        raw"V^i_j",
        raw"x_{i_j}",
        raw"x^{i^j}",
        raw"x_{(a+b)_k}^i",
        raw"T_{\alpha\beta}^{ij}",
        raw"\Gamma^\mu_{\nu\rho}",
        raw"\psi^\dagger_i\psi_i",
    ],
    "PR #151 primes and deep scripts" => [
        raw"x' f'",
        raw"x'' f''",
        raw"x′ f′",
        raw"x\prime f\prime",
        raw"x^\prime f^\prime",
        raw"x'_y f_g'",
        raw"A^{B^{C^{D^E}}}_{F_{G_{H_I}}}",
        raw"f^{A'}",
    ],
    "Roman upright and capital boundaries" => [
        raw"\mathrm{d}x",
        raw"\mathrm{e}^{-x}",
        raw"\mathrm{Re}\,z",
        raw"\mathrm{Im}\,z",
        raw"\mathrm{Tr}\,A_i^j",
        raw"\mathrm{Cov}(X,Y)",
        raw"A_\nu B_\nu C_\nu D_\nu",
        raw"M\mathrm{M}M",
    ],
    "Issue #129 math operator spacing" => [
        raw"\log x",
        raw"\log(x)",
        raw"\sin x",
        raw"\sin(x)",
        raw"\exp t",
        raw"\exp(t)",
        raw"\max_{t \in \{1,...,5\}}",
    ],
    "Operators, delimiters, and fractions" => [
        raw"-1,\ 2-1,\ (-1)",
        raw"\alpha^*",
        raw"\psi^* \psi",
        raw"\frac{1}{2}\pm\sqrt{3}",
        raw"\frac{1}{2}{}\pm\sqrt{3}",
        raw"\left(\frac{1}{2}\right)f(t)",
        raw"\sqrt{x_i^2+y_i^2}",
        raw"\sum_{k=0}^n a_k x^k",
        raw"\int_0^{2\pi}\sin(x)\,dx",
    ],
    "Script layout issues #93, #105, #110, #126" => [
        raw"\left(\frac{dy}{dx}\right)_0",
        raw"\left(\frac{A^{xy}}{B}\right)^{1/4}",
        raw"(\frac{A^{xy}}{B})^{1/4}",
        raw"\left\langle\left|\int\right|\right\rangle",
        raw"\left\langle\left|\left\langle\left|\int\right|\right\rangle\right|\right\rangle",
        raw"x^{\frac{1}{1+2}}",
        raw"x_{\frac{1}{1+2}}",
    ],
    "Nested expressions" => [
        raw"\frac{\alpha_i+\beta_i}{\gamma_i+\delta_i}",
        raw"\sqrt{\frac{1+\alpha_k}{1+\beta_k}}",
        raw"F_{\mu\nu}F^{\mu\nu}",
        raw"\overline{z}_i",
        raw"\left(\alpha_{(i+j)_k}\right)^2",
        raw"\frac{\partial^2 f}{\partial x_i\partial x_j}",
    ],
)

const _math_font_mappings = Dict(
    :bb => to_blackboardbold,
    :cal => to_caligraphic,
    :frak => to_frakture,
    :scr => to_caligraphic
)

"""
    TeXExpr(head::Symbol, args::Vector)

A TeX expression, represented by a head and any number of arguments.

See the documentation to see the valid combinations of head and arguments,
and the meaning of the latter.

Fields
======
    - head::Symbol
    - args::Vector
"""
struct TeXExpr
    head::Symbol
    args::Vector{Any}

    function TeXExpr(head, args::Vector)
        # Convert math font like `\mathbb{R}` -- TeXExpr(:font, [:bb, 'R']) --
        # to unicode symbols -- e.g. TeXExpr(:symbol, 'ℝ')
        if length(args) == 2 && head == :font && haskey(_math_font_mappings, args[1])
            font, content = args
            to_font = _math_font_mappings[font]
            return leafmap(content) do leaf
                sym = only(leaf.args)
                return TeXExpr(:symbol, to_font(sym))
            end
        end

        return new(head, args)
    end
end

TeXExpr(head) = TeXExpr(head, [])
TeXExpr(head, args...) = TeXExpr(head, collect(args))
TeXExpr(head, arg) = TeXExpr(head, [arg])

Base.push!(texexpr::TeXExpr, arg) = push!(texexpr.args, arg)
Base.pop!(texexpr::TeXExpr) = pop!(texexpr.args)
Base.copy(texexpr::TeXExpr) = TeXExpr(texexpr.head, deepcopy(texexpr.args))

function Base.Char(texexpr::TeXExpr)
    if isleaf(texexpr)
        return texexpr.args[1]
    end

    throw(ArgumentError("cannot convert TeXExpr with head $(texexpr.head) to Char."))
end

"""
    manual_texexpr(data)

Convenience function to manually create a TeXExpr from tuples or latex strings.

# Example
julia> manual_texexpr((:expr, 'a', (:spaced, '+'), raw"\\omega^2"))
TeXExpr :expr
├─ 'a'
├─ TeXExpr :spaced
│  └─ '+'
└─ TeXExpr :decorated
   ├─ TeXExpr :symbol
   │  ├─ 'ω'
   │  └─ "\\omega"
   ├─ nothing
   └─ '2'
```
"""
function manual_texexpr(tuple::Tuple)
    head = tuple[1]
    args = []

    if head in [:char, :delimiter, :digit, :punctuation, :symbol]
        return TeXExpr(head, tuple[2])
    end

    for arg in tuple[2:end]
        push!(args, manual_texexpr(arg))
    end

    return TeXExpr(head, args)
end

function manual_texexpr(str::LaTeXString)
    expr = texparse(str[2:end-1])
    if length(expr.args) == 1
        return first(expr.args)
    else
        return TeXExpr(:group, expr.args)
    end
end

manual_texexpr(char::Char) = TeXExpr(:char, char)
manual_texexpr(any) = any

head(texexpr::TeXExpr) = texexpr.head
head(::Char) = :char
isleaf(texexpr::TeXExpr) = texexpr.head in (:char, :delimiter, :digit, :punctuation, :symbol)
isleaf(::Nothing) = true

function AbstractTrees.children(texexpr::TeXExpr)
    isleaf(texexpr) && return TeXExpr[]
    return texexpr.args
end

function AbstractTrees.printnode(io::IO, texexpr::TeXExpr)
    if isleaf(texexpr)
        print(io, "TeXExpr :$(texexpr.head) '$(only(texexpr.args))'")
    else
        print(io, "TeXExpr :$(texexpr.head)")
    end
end

function Base.show(io::IO, texexpr::TeXExpr)
    print_tree(io, texexpr, maxdepth=10)
end

function Base.:(==)(tex1::TeXExpr, tex2::TeXExpr)
    childs1 = children(tex1)
    childs2 = children(tex2)

    length(childs1) != length(childs2) && return false

    return all(childs1 .== childs2)
end

"""
    leafmap(f, texexpr::TeXExpr)

Return a TeXExpr with the same structure, but all leaf expression `leaf`
replaced by `f(leaf)`.
"""
function leafmap(f, texexpr::TeXExpr)
    isleaf(texexpr) && return f(texexpr)

    args = map(texexpr.args) do arg
        arg isa TeXExpr || return arg
        return leafmap(f, arg)
    end

    return TeXExpr(texexpr.head, args)
end

using CairoMakie
using Colors
using FileIO
using MathTeXEngine
using Tar
using Test
using TOML

include("references.jl")

function download_refimages(tag = "refimages-v4")
    url = "https://github.com/Kolaru/MathTeXEngine.jl/releases/download/$tag/reference_images.tar"
    images_tar = joinpath(@__DIR__, "reference_images.tar")
    images = joinpath(@__DIR__, "reference_images")
    if isfile(images_tar)
        if Bool(parse(Int, get(ENV, "REUSE_IMAGES_TAR", "0")))
            @info "$images_tar already exists, skipping download as requested"
        else
            rm(images_tar)
        end
    end
    !isfile(images_tar) && download(url, images_tar)
    isdir(images) && rm(images, recursive = true, force = true)
    Tar.extract(images_tar, images)
    return images
end

function image_paths(references)
    paths = String[]
    for (group, data) in references
        if data isa AbstractDict
            append!(paths, joinpath.(Ref(group), image_paths(data)))
        else
            push!(paths, "$group.png")
        end
    end

    return paths
end

n_bad_pixels(img1, img2) = count(>(0.5), image_difference(img1, img2))
image_difference(img1, img2) = colordiff.(img1, img2) ./ 100

@testset "Reference images" begin
    @info "Reference test started"

    @info "Downloading reference images"
    reference_images = download_refimages()
    @info "Reference images downloaded in $reference_images"
    
    @info "Generating comparison images"
    comparison_images = joinpath(@__DIR__, "comparison_images")
    rm(comparison_images, recursive = true, force = true)
    generate(comparison_images)
    @info "Comparison images generated in $comparison_images"
    
    # Compare
    reference_comparison_images = joinpath(@__DIR__, "reference_comparison_images")
    rm(reference_comparison_images, recursive = true, force = true)
    path = mkpath(reference_comparison_images)

    @info "Comparing images"
    for image_path in image_paths(REFERENCES)
        @info "Comparing $image_path"

        refimg = rotr90(load(joinpath(reference_images, image_path)))
        img = rotr90(load(joinpath(comparison_images, image_path)))

        if (failed = (size(img) != size(refimg) || n_bad_pixels(img, refimg) >= 10))
            @info "Saving the reference comparison for '$image_path'"
            fig = Figure(size = (3*size(img, 1), size(img, 2)))
            Label(fig[1, 1], "Reference $(size(refimg))", tellwidth=false)
            axref = Axis(fig[2, 1], aspect = DataAspect())
            hidedecorations!(axref)
            image!(axref, refimg)

            Label(fig[1, 2], "Current $(size(img))", tellwidth=false)
            axcurrent = Axis(fig[2, 2], aspect = DataAspect())
            hidedecorations!(axcurrent)
            image!(axcurrent, img)

            if size(img) == size(refimg)
                Label(fig[1, 3], "Difference ($(n_bad_pixels(img, refimg)) bad pixels). Blue: reference. Orange: current.", tellwidth=false)
                axdiff = Axis(fig[2, 3], aspect = DataAspect())
                hidedecorations!(axdiff)
                diff = Gray.(img) - Gray.(refimg)
                overlay = RGB.(Gray.(refimg), Gray.(img)./2 .+ Gray.(refimg)./2, Gray.(img))

                image!(axdiff, overlay)
            end

            comparison_path = joinpath(path, image_path)
            mkpath(dirname(comparison_path))
            @info "Saving the reference plot at $comparison_path"
            save(comparison_path, fig)
        end
        @test !failed
    end
end

##
## Spaced symbols
##
# Symbols that need extra space around them

binary_operator_symbols = split("+ * −")
binary_operator_commands = split(raw"""
    \pm             \sqcap                   
    \mp             \sqcup                   
    \times          \vee                     
    \div            \wedge                   \oplus
    \ast            \setminus                \ominus
    \star           \wr                      \otimes
    \circ           \diamond                 \oslash
    \bullet         \bigtriangleup           \odot
    \cdot           \bigtriangledown         \bigcirc
    \cap            \triangleleft            \dagger
    \cup            \triangleright           \ddagger
    \uplus          \amalg""")

relation_symbols = split(raw"= < > :")
relation_commands = split(raw"""
    \leq        \geq        \equiv   \models
    \prec       \succ       \sim     \perp
    \lesssim    \gtrsim
    \preceq     \succeq     \simeq   \mid
    \ll         \gg         \asymp   \parallel
    \subset     \supset     \approx  \bowtie
    \subseteq   \supseteq   \cong    \join
    \sqsubset   \sqsupset   \neq     \smile
    \sqsubseteq \sqsupseteq \doteq   \frown
    \in         \ni         \propto  \vdash
    \dashv      \dots       \dotplus""")

arrow_commands = split(raw"""
    \leftarrow              \longleftarrow           \uparrow
    \Leftarrow              \Longleftarrow           \Uparrow
    \rightarrow             \longrightarrow          \downarrow
    \Rightarrow             \Longrightarrow          \Downarrow
    \leftrightarrow         \longleftrightarrow      \updownarrow
    \Leftrightarrow         \Longleftrightarrow      \Updownarrow
    \mapsto                 \longmapsto              \nearrow
    \hookleftarrow          \hookrightarrow          \searrow
    \leftharpoonup          \rightharpoonup          \swarrow
    \leftharpoondown        \rightharpoondown        \nwarrow
    \rightleftharpoons""")

spaced_symbols = first.(vcat(binary_operator_symbols, relation_symbols))
spaced_commands = vcat(binary_operator_commands, relation_commands, arrow_commands)

##
## Subsuper commands
##
# Functions and symbols that expect subscript and/or superscript

underover_commands = split(raw"""
    \sum \prod \coprod \bigcap \bigcup \bigsqcup \bigvee
    \bigwedge \bigodot \bigotimes \bigoplus \biguplus""")

underover_functions = split(raw"lim liminf limsup inf sup min max")
integral_commands = split(raw"\int \oint")

##
## Generic functions
##

generic_functions = split(raw"""
    arccos csc ker arcsin deg lg Pr arctan det sec arg dim
    sin cos exp sinh cosh gcd ln sup cot hom log tan
    coth tanh""")

##
## Spaces
##

space_commands = Dict(
    raw"\,"         => 0.16667,   # 3/18 em = 3 mu
    raw"\thinspace" => 0.16667,   # 3/18 em = 3 mu
    raw"\/"         => 0.16667,   # 3/18 em = 3 mu
    raw"\>"         => 0.22222,   # 4/18 em = 4 mu
    raw"\:"         => 0.22222,   # 4/18 em = 4 mu
    raw"\;"         => 0.27778,   # 5/18 em = 5 mu
    raw"\ "         => 0.33333,   # 6/18 em = 6 mu
    raw"\enspace"   => 0.5,       # 9/18 em = 9 mu
    raw"\quad"      => 1,         # 1 em = 18 mu
    raw"\qquad"     => 2,         # 2 em = 36 mu
    raw"\!"         => -0.16667,  # -3/18 em = -3 mu
)

space_symbols = Dict(
    '~'          => 0.33333,   # 6/18 em = 6 mu, nonbreakable
)

##
## Accents
##

combining_accents = [
    raw"\hat",
    raw"\breve",
    raw"\bar",
    raw"\grave",
    raw"\acute",
    raw"\tilde",
    raw"\dot",
    raw"\ddot",
    raw"\vec"
]

punctuation_symbols = split(raw", ; . !")
delimiter_symbols = split(raw"| / \ ( ) [ ] ⟨ ⟩ ‖ ⌈ ⌉ ⌊ ⌋ ⌜ ⌝ ⌞ ⌟")
    ## NOTE `<` and `>` not included in `delimiter_symbols` because 
    ##      they should not be used as such. In math mode, they are relation symbols and
    ##      we don't want to change that by overwriting the `symbol_to_canonical` entries.
    ##      **However**, `\left<` and `\right>` should work to produce `\left\langle` and 
    ##      `\right\rangle`, respectively, due to intercepting `delimiter(...)`.
    ## NOTE `{` and `}` not included because they are group delimiters that the tokenizer
    ##      should recognize as `lcurly` and `rcurly`. 
    ##      The symbols have to be typed by command.

## some delimiter symbols can also be typed with commands;
### instead of relying on `get_symbol_char` (like with `space_commands` in `commands_registration.jl`)
### we define them explicitly, because `latex_symbols` misses some
delimiter_commands = Dict(
    raw"\vert" => '|',
    raw"\slash" => '/',         # NOTE seems to work with LaTeX, but not MathJax
    raw"\backslash" => '\\',
    raw"\lbrack" => '[',
    raw"\rbrack" => ']',
    raw"\langle" => '⟨',
    raw"\rangle" => '⟩',
    raw"\|" => '‖',
    raw"\Vert" => '‖',
    raw"\lceil" => '⌈',
    raw"\rceil" => '⌉',
    raw"\lfloor" => '⌊',
    raw"\lfloor" => '⌊',
    raw"\ulcorner" => '⌜',
    raw"\urcorner" => '⌝',
    raw"\llcorner" => '⌞',
    raw"\lrcorner" => '⌟',
    raw"\{" => '{',
    raw"\}" => '}',
    raw"\lbrace" => '{',
    raw"\rbrace" => '}',
)

font_names = split(raw"rm cal it tt sf bf default bb frak scr regular")

# TODO Add to the parser what come below, if needed
wide_accent_commands = split(raw"\widehat \widetilde \widebar")

using Test

using MathTeXEngine

import MathTeXEngine: manual_texexpr, texparse
import MathTeXEngine: TeXParseError

import MathTeXEngine: tex_layout, generate_tex_elements
import MathTeXEngine: Space, TeXElement
import MathTeXEngine: load_font
import MathTeXEngine: hadvance, inkheight, inkwidth, xheight
import MathTeXEngine: bottominkbound, leftinkbound, rightinkbound, topinkbound

include("texexpr.jl")
include("parser.jl")
include("fonts.jl")
include("layout.jl")

using Tar

include("references.jl")

begin
    @info "Generating reference images"
    reference_images = joinpath(@__DIR__, "reference_images")
    rm(reference_images, recursive = true, force = true)
    generate(reference_images)
    Tar.create(reference_images, "reference_images.tar")
end
